// =============================================================================
// Copyright 2008-2011. Intel Corporation All Rights Reserved.
//
// The source code contained or described herein and all documents related to 
// the source code ("Material") are owned by Intel Corporation or its suppliers 
// or licensors. Title to the Material remains with Intel Corporation or its 
// suppliers and licensors. The Material may contain trade secrets and 
// proprietary and confidential information of Intel Corporation and its 
// suppliers and licensors, and is protected by worldwide copyright and trade 
// secret laws and treaty provisions. No part of the Material may be used, 
// copied, reproduced, modified, published, uploaded, posted, transmitted, 
// distributed, or disclosed in any way without Intels prior express written 
// permission. 
//
// No license under any patent, copyright, trade secret or other intellectual 
// property right is granted to or conferred upon you by disclosure or delivery 
// of the Materials, either expressly, by implication, inducement, estoppel or 
// otherwise. Any license under such intellectual property rights must be 
// express and approved by Intel in writing.
// =============================================================================
#ifndef __HECI_WIN_H__
#define __HECI_WIN_H__

#include <windows.h>
#define HECI_MAX_LINE_LEN                   300 

GUID _guid;
bool _initialized;
bool _verbose;
unsigned long _bufSize;

int __stdcall HECI_Init(char* guid);
void __stdcall HECI_Deinit();
int __stdcall HECI_ReceiveMessage(void *buffer, int len, int timeout = 2000);
int __stdcall HECI_SendMessage(void *buffer, int len, int timeout = 0xFFFFFFFF);
unsigned long __stdcall HECI_GetBufferSize() { return _bufSize; }
HANDLE __stdcall HECI_GetHandle();
int __stdcall HECI_doIoctl(DWORD code, void *inbuf, int inlen, void *outbuf, int outlen);

static TCHAR *_getErrMsg(DWORD err);
VOID _displayHECIError(UINT32 errorCode,DWORD lastError);
VOID _displayHECIData(UINT32 messageId);
HANDLE _handle;


/*
#include <windows.h>
#include "HECI.h"
#define HECI_MAX_LINE_LEN                   300 

class HECIWin : public HECI {
public:
	HECIWin(const GUID guid, bool verbose = false);
	virtual ~HECIWin();

	virtual bool Init();
	virtual void Deinit();
	virtual int ReceiveMessage(unsigned char *buffer, int len, unsigned long timeout = 2000);
	virtual int SendMessage(unsigned char *buffer, int len, unsigned long timeout = 0xFFFFFFFF);
	virtual unsigned long GetBufferSize() { return _bufSize; }

	HANDLE GetHandle();

private:
	int _doIoctl(DWORD code, void *inbuf, int inlen, void *outbuf, int outlen);
	static TCHAR *_getErrMsg(DWORD err);
    VOID _displayHECIError(UINT32 errorCode,DWORD lastError);
    VOID _displayHECIData(UINT32 messageId);

	HANDLE _handle;
};
*/

#endif
