// =============================================================================
// Copyright 2008-2011. Intel Corporation All Rights Reserved.
//
// The source code contained or described herein and all documents related to 
// the source code ("Material") are owned by Intel Corporation or its suppliers 
// or licensors. Title to the Material remains with Intel Corporation or its 
// suppliers and licensors. The Material may contain trade secrets and 
// proprietary and confidential information of Intel Corporation and its 
// suppliers and licensors, and is protected by worldwide copyright and trade 
// secret laws and treaty provisions. No part of the Material may be used, 
// copied, reproduced, modified, published, uploaded, posted, transmitted, 
// distributed, or disclosed in any way without Intels prior express written 
// permission. 
//
// No license under any patent, copyright, trade secret or other intellectual 
// property right is granted to or conferred upon you by disclosure or delivery 
// of the Materials, either expressly, by implication, inducement, estoppel or 
// otherwise. Any license under such intellectual property rights must be 
// express and approved by Intel in writing.
// =============================================================================
//----------------------------------------------------------------------------
//
//  Copyright (C) Intel Corporation, 2004 - 2006.
//
//  File:       StatusStrings.h 
//
//  Contents:   header file of StatusStrings DLL
//
//----------------------------------------------------------------------------

#include <tchar.h>
#include <windows.h>

/*
 * Loads the string with the given identifier from the StringTable into the 
 * given wchar buffer.
 * Arguments:
 *  status - the identifier of the string to be loaded. 
 *  message - pointer to the buffer to receive the string. 
 *  bufferMax - specifies the size of the buffer, in wchars. The string is 
 *              truncated and null terminated if it is longer than the number 
 *              of characters specified. 
 * Return value:
 *  If the string is found, returns the length (in wchars) of the loaded string
 *  (not including the null terminating char).
 *  If the string was not found, returns 0.
 */
extern "C" _declspec(dllimport) int GetStatusString(UINT status, wchar_t* message, int bufferMax);
