// =============================================================================
// Copyright 2008-2011. Intel Corporation All Rights Reserved.
//
// The source code contained or described herein and all documents related to 
// the source code ("Material") are owned by Intel Corporation or its suppliers 
// or licensors. Title to the Material remains with Intel Corporation or its 
// suppliers and licensors. The Material may contain trade secrets and 
// proprietary and confidential information of Intel Corporation and its 
// suppliers and licensors, and is protected by worldwide copyright and trade 
// secret laws and treaty provisions. No part of the Material may be used, 
// copied, reproduced, modified, published, uploaded, posted, transmitted, 
// distributed, or disclosed in any way without Intels prior express written 
// permission. 
//
// No license under any patent, copyright, trade secret or other intellectual 
// property right is granted to or conferred upon you by disclosure or delivery 
// of the Materials, either expressly, by implication, inducement, estoppel or 
// otherwise. Any license under such intellectual property rights must be 
// express and approved by Intel in writing.
// =============================================================================
#ifndef __HECI_H__
#define __HECI_H__

#include <memory.h>

#ifndef GUID_DEFINED
#define GUID_DEFINED
//typedef char GUID[16];
typedef struct guid
{
    unsigned long  data1;
    unsigned short data2;
    unsigned short data3;
    unsigned char  data4[8];
} GUID;
#endif

class HECI {
public:
	HECI(const GUID guid, bool verbose = false): _initialized(false), _verbose(verbose), _bufSize(0) {
		memcpy(&_guid, &guid, sizeof(_guid));
	}
	virtual ~HECI() {}

	virtual bool Init() = 0;
	virtual void Deinit() = 0;
	virtual int ReceiveMessage(unsigned char *buffer, int len, unsigned long timeout = 2000) = 0;
	virtual int SendMessage(unsigned char *buffer, int len, unsigned long timeout = 2000) = 0;
	virtual unsigned long GetBufferSize() = 0;

protected:
	GUID _guid;
	bool _initialized;
	bool _verbose;
	unsigned long _bufSize;
};

#endif
