// =============================================================================
// Copyright 2008-2011. Intel Corporation All Rights Reserved.
//
// The source code contained or described herein and all documents related to 
// the source code ("Material") are owned by Intel Corporation or its suppliers 
// or licensors. Title to the Material remains with Intel Corporation or its 
// suppliers and licensors. The Material may contain trade secrets and 
// proprietary and confidential information of Intel Corporation and its 
// suppliers and licensors, and is protected by worldwide copyright and trade 
// secret laws and treaty provisions. No part of the Material may be used, 
// copied, reproduced, modified, published, uploaded, posted, transmitted, 
// distributed, or disclosed in any way without Intels prior express written 
// permission. 
//
// No license under any patent, copyright, trade secret or other intellectual 
// property right is granted to or conferred upon you by disclosure or delivery 
// of the Materials, either expressly, by implication, inducement, estoppel or 
// otherwise. Any license under such intellectual property rights must be 
// express and approved by Intel in writing.
// =============================================================================
using System;
using System.Data;
using System.Text;
using System.Drawing;
using System.Windows.Forms;
using System.ComponentModel;
using System.Collections.Generic;
using ManageabilityStack;

namespace ManageabilityCommanderTool
{
    public partial class AddEventFilterForm : Form
    {
        public AddEventFilterForm()
        {
            InitializeComponent();

            // Setup Sensor Type Combo
            int i = 0;
            sensorTypeComboBox.Items.Add(new Utils.DropDownItem(ManageabilityCommanderTool.Properties.Resources.AddEvtFlt_SenTy_Drop_0, 0xFF, null));
            foreach (string sensorType in AmtEventData.EventSensorTypes)
            {
                sensorTypeComboBox.Items.Add(new Utils.DropDownItem(sensorType, i, null));
                i++;
            }
            sensorTypeComboBox.SelectedIndex = 0;

            // Setup Event Type Combo
            i = 0;
            eventTypeComboBox.Items.Add(new Utils.DropDownItem(ManageabilityCommanderTool.Properties.Resources.AddEvtFlt_EvtTy_Drop_0, 0xFF, null));
            foreach (string eventType in AmtEventData.EventTypes)
            {
                eventTypeComboBox.Items.Add(new Utils.DropDownItem(eventType, i, null));
                i++;
            }
            eventTypeComboBox.SelectedIndex = 0;

            // Setup Event Source
            i = 0;
            eventSourceComboBox.Items.Add(new Utils.DropDownItem(ManageabilityCommanderTool.Properties.Resources.AddEvtFlt_EvtSrc_Drop_0, 0xFF, null));
            foreach (string eventType in AmtEventData.EventTrapSourceTypes)
            {
                eventSourceComboBox.Items.Add(new Utils.DropDownItem(eventType, i, null));
                i++;
            }
            eventSourceComboBox.SelectedIndex = 0;

            // Setup Event Severity (!!! NOT A FILTER FIELD !!!)
            eventSeverityComboBox.Items.Add(new Utils.DropDownItem(ManageabilityCommanderTool.Properties.Resources.AddEvtFlt_EvtSvt_Drop_0, 0x00, null));
            eventSeverityComboBox.Items.Add(new Utils.DropDownItem(ManageabilityCommanderTool.Properties.Resources.AddEvtFlt_EvtSvt_Drop_1, 0x01, null));
            eventSeverityComboBox.Items.Add(new Utils.DropDownItem(ManageabilityCommanderTool.Properties.Resources.AddEvtFlt_EvtSvt_Drop_2, 0x02, null));
            eventSeverityComboBox.Items.Add(new Utils.DropDownItem(ManageabilityCommanderTool.Properties.Resources.AddEvtFlt_EvtSvt_Drop_3, 0x04, null));
            eventSeverityComboBox.Items.Add(new Utils.DropDownItem(ManageabilityCommanderTool.Properties.Resources.AddEvtFlt_EvtSvt_Drop_4, 0x08, null));
            eventSeverityComboBox.Items.Add(new Utils.DropDownItem(ManageabilityCommanderTool.Properties.Resources.AddEvtFlt_EvtSvt_Drop_5, 0x10, null));
            eventSeverityComboBox.Items.Add(new Utils.DropDownItem(ManageabilityCommanderTool.Properties.Resources.AddEvtFlt_EvtSvt_Drop_6, 0x20, null));
            eventSeverityComboBox.SelectedIndex = 0;

            // Setup Sensor Device
            sensorDeviceComboBox.Items.Add(new Utils.DropDownItem(ManageabilityCommanderTool.Properties.Resources.AddEvtFlt_SenDev_Drop_0, 0xFF, null));
            for (i = 0; i < 255; i++)
            {
                sensorDeviceComboBox.Items.Add(new Utils.DropDownItem(ManageabilityCommanderTool.Properties.Resources.AddEvtFlt_DEV + i.ToString(), i, null));
            }
            sensorDeviceComboBox.SelectedIndex = 0;

            // Setup Sensor Number
            sensorNumberComboBox.Items.Add(new Utils.DropDownItem(ManageabilityCommanderTool.Properties.Resources.AddEvtFlt_SenNum_Drop_0, 0xFF, null));
            for (i = 0; i < 255; i++)
            {
                sensorNumberComboBox.Items.Add(new Utils.DropDownItem(ManageabilityCommanderTool.Properties.Resources.AddEvtFlt_SEN + i.ToString(), i, null));
            }
            sensorNumberComboBox.SelectedIndex = 0;

            // Setup Entity Type Combo
            i = 0;
            entityComboBox.Items.Add(new Utils.DropDownItem(ManageabilityCommanderTool.Properties.Resources.AddEvtFlt_EttType_Drop_0, 0, null));
            foreach (string eventType in AmtEventData.EntityTypes)
            {
                if (i != 0) entityComboBox.Items.Add(new Utils.DropDownItem(eventType, i, null));
                i++;
            }
            entityComboBox.SelectedIndex = 0;

            // Setup Entity Instance
            entityInstanceComboBox.Items.Add(new Utils.DropDownItem(ManageabilityCommanderTool.Properties.Resources.AddEvtFlt_EttInst_Drop_0, 0, null));
            for (i = 1; i < 255; i++)
            {
                entityInstanceComboBox.Items.Add(new Utils.DropDownItem(ManageabilityCommanderTool.Properties.Resources.AddEvtFlt_INS + i.ToString(), i, null));
            }
            entityInstanceComboBox.SelectedIndex = 0;

            // Setup Filter Action Combo
            actionComboBox.Items.Add(new Utils.DropDownItem(ManageabilityCommanderTool.Properties.Resources.AddEvtFlt_Act_Drop_0, 0, null));
            actionComboBox.Items.Add(new Utils.DropDownItem(ManageabilityCommanderTool.Properties.Resources.AddEvtFlt_Act_Drop_1, 1, null));
            actionComboBox.Items.Add(new Utils.DropDownItem(ManageabilityCommanderTool.Properties.Resources.AddEvtFlt_Act_Drop_2, 2, null));
            actionComboBox.Items.Add(new Utils.DropDownItem(ManageabilityCommanderTool.Properties.Resources.AddEvtFlt_Act_Drop_3, 3, null));
            actionComboBox.SelectedIndex = 3;

            SetEventOffsetCombo();
        }

        public bool PolicyIdReadOnly
        {
            get { return policyIdTextBox.ReadOnly; }
            set { policyIdTextBox.ReadOnly = value; }
        }

        public EventFilterType GetFilter()
        {
            EventFilterType filter = new EventFilterType();

            // Set the filter action
            if (actionComboBox.SelectedIndex != 0) filter.FilterConfiguration = 0x80;
            if (actionComboBox.SelectedIndex == 1) filter.FilterAction = 0x80;
            if (actionComboBox.SelectedIndex == 2) filter.FilterAction = 0x01;
            if (actionComboBox.SelectedIndex == 3) filter.FilterAction = 0x81;

            filter.EventSensorType = (byte)((Utils.DropDownItem)sensorTypeComboBox.SelectedItem).Handle;
            filter.EventType = (byte)((Utils.DropDownItem)eventTypeComboBox.SelectedItem).Handle;

            if (eventOffsetComboBox.SelectedItem != null)
            {
                filter.EventOffset = (byte)((Utils.DropDownItem)eventOffsetComboBox.SelectedItem).Handle;
                if (deassertCheckBox.Checked) filter.EventOffset += 128;
            }
            else
            {
                filter.EventOffset = 0x0F;
            }

            filter.EventSourceType = (byte)((Utils.DropDownItem)eventSourceComboBox.SelectedItem).Handle;
            filter.EventSeverity = (byte)((Utils.DropDownItem)eventSeverityComboBox.SelectedItem).Handle;
            filter.DeviceAddress = (byte)((Utils.DropDownItem)sensorDeviceComboBox.SelectedItem).Handle;
            filter.SensorNumber = (byte)((Utils.DropDownItem)sensorNumberComboBox.SelectedItem).Handle;
            filter.Entity = (byte)((Utils.DropDownItem)entityComboBox.SelectedItem).Handle;
            filter.EntityInstance = (byte)((Utils.DropDownItem)entityInstanceComboBox.SelectedItem).Handle;
            byte policyId = 0;
            byte.TryParse(policyIdTextBox.Text, out policyId);
            filter.AlertSubscriptionPolicyID = policyId;

            return filter;
        }

        public void SetFilter(EventFilterType filter)
        {
            // Set the filter action
            if ((filter.FilterConfiguration & 0x80) == 0)
            {
                actionComboBox.SelectedIndex = 0;
            }
            else
            {
                if ((filter.FilterAction & 0x81) == 0x80) actionComboBox.SelectedIndex = 1;
                if ((filter.FilterAction & 0x81) == 0x01) actionComboBox.SelectedIndex = 2;
                if ((filter.FilterAction & 0x81) == 0x81) actionComboBox.SelectedIndex = 3;
            }

            SetCombo(sensorTypeComboBox, filter.EventSensorType);
            SetCombo(eventTypeComboBox, filter.EventType);
            SetEventOffsetCombo();

            byte offset = filter.EventOffset;
            if (offset > 127)
            {
                offset -= 128;
                deassertCheckBox.Checked = true;
            }
            else
            {
                deassertCheckBox.Checked = false;
            }
            SetCombo(eventOffsetComboBox, offset);

            SetCombo(eventSourceComboBox, filter.EventSourceType);
            SetCombo(eventSeverityComboBox, filter.EventSeverity);
            SetCombo(sensorDeviceComboBox, filter.DeviceAddress);
            SetCombo(sensorNumberComboBox, filter.SensorNumber);
            SetCombo(entityComboBox, filter.Entity);
            SetCombo(entityInstanceComboBox, filter.EntityInstance);

            policyIdTextBox.Text = filter.AlertSubscriptionPolicyID.ToString();

            UpdateInfo();
        }

        private void SetCombo(ComboBox comboBox, int handle)
        {
            foreach (Utils.DropDownItem d in comboBox.Items)
            {
                if (d.Handle == handle)
                {
                    comboBox.SelectedItem = d;
                    return;
                }
            }
        }

        private void okButton_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.OK;
        }

        private void policyIdTextBox_TextChanged(object sender, EventArgs e)
        {
            int ss = policyIdTextBox.SelectionStart;
            int sl = policyIdTextBox.SelectionLength;
            policyIdTextBox.Text = Utils.FilterNumber(policyIdTextBox.Text);
            policyIdTextBox.SelectionStart = ss;
            policyIdTextBox.SelectionLength = sl;
            UpdateInfo();
        }

        private void UpdateInfo()
        {
            bool ok = true;
            try
            {
                uint i = uint.Parse(policyIdTextBox.Text);
                if (i > byte.MaxValue) ok = false;
            }
            catch (Exception) { ok = false; }

            okButton.Enabled = ok;
        }

        private void eventTypeComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            SetEventOffsetCombo();
        }

        private void SetEventOffsetCombo()
        {
            string[] offsets = AmtEventData.GetEventOffsets((byte)((Utils.DropDownItem)eventTypeComboBox.SelectedItem).Handle);

            eventOffsetComboBox.Items.Clear();
            if (offsets != null)
            {
                int i = 0;
                foreach (string s in offsets)
                {
                    eventOffsetComboBox.Items.Add(new Utils.DropDownItem(s, i, null));
                    i++;
                }
                eventOffsetComboBox.SelectedIndex = 0;
                eventOffsetComboBox.Enabled = true;
            }
            else
            {
                eventOffsetComboBox.Enabled = false;
            }
        }

        private void AddEventFilterForm_Load(object sender, EventArgs e)
        {
            if (this.Owner != null) Icon = Owner.Icon;
        }

    }
}
