// =============================================================================
// Copyright 2008-2011. Intel Corporation All Rights Reserved.
//
// The source code contained or described herein and all documents related to 
// the source code ("Material") are owned by Intel Corporation or its suppliers 
// or licensors. Title to the Material remains with Intel Corporation or its 
// suppliers and licensors. The Material may contain trade secrets and 
// proprietary and confidential information of Intel Corporation and its 
// suppliers and licensors, and is protected by worldwide copyright and trade 
// secret laws and treaty provisions. No part of the Material may be used, 
// copied, reproduced, modified, published, uploaded, posted, transmitted, 
// distributed, or disclosed in any way without Intels prior express written 
// permission. 
//
// No license under any patent, copyright, trade secret or other intellectual 
// property right is granted to or conferred upon you by disclosure or delivery 
// of the Materials, either expressly, by implication, inducement, estoppel or 
// otherwise. Any license under such intellectual property rights must be 
// express and approved by Intel in writing.
// =============================================================================
using System;
using System.Data;
using System.Text;
using System.Drawing;
using System.Windows.Forms;
using System.ComponentModel;
using System.Collections.Generic;

namespace ManageabilityCommanderTool
{
    public partial class AdvancedPropertiesForm : Form
    {
        public AdvancedPropertiesForm()
        {
            InitializeComponent();
        }

        private void AdvancedPropertiesForm_Load(object sender, EventArgs e)
        {
            if (this.Owner != null) Icon = Owner.Icon;

            wsmanSupportCheckBox.Checked = Properties.Settings.Default.WsmanSupport;

            solCustomRadioButton.Checked = (((string)Application.UserAppDataRegistry.GetValue("SOL-Timeout", Boolean.FalseString)).CompareTo(Boolean.TrueString) == 0);
            numericUpDown0.Value = int.Parse((string)Application.UserAppDataRegistry.GetValue("SOL-Timeout-1", "0"));
            numericUpDown1.Value = int.Parse((string)Application.UserAppDataRegistry.GetValue("SOL-Timeout-2", "100"));
            numericUpDown2.Value = int.Parse((string)Application.UserAppDataRegistry.GetValue("SOL-Timeout-3", "5000"));
            numericUpDown3.Value = int.Parse((string)Application.UserAppDataRegistry.GetValue("SOL-Timeout-4", "100"));
            numericUpDown4.Value = int.Parse((string)Application.UserAppDataRegistry.GetValue("SOL-Timeout-5", "10000"));

            iderCustomRadioButton.Checked = (((string)Application.UserAppDataRegistry.GetValue("IDER-Timeout", Boolean.FalseString)).CompareTo(Boolean.TrueString) == 0);
            numericUpDown10.Value = int.Parse((string)Application.UserAppDataRegistry.GetValue("IDER-Timeout-1", "10000"));
            numericUpDown11.Value = int.Parse((string)Application.UserAppDataRegistry.GetValue("IDER-Timeout-2", "0"));
            numericUpDown12.Value = int.Parse((string)Application.UserAppDataRegistry.GetValue("IDER-Timeout-3", "5000"));

            httpTimeoutNumericUpDown.Value = ManageabilityStack.AmtSystem.HttpTimeout;

            if (solCustomRadioButton.Checked == false)
            {
                numericUpDown0.Value = 0;
                numericUpDown1.Value = 100;
                numericUpDown2.Value = 5000;
                numericUpDown3.Value = 100;
                numericUpDown4.Value = 10000;
            }

            if (iderCustomRadioButton.Checked == false)
            {
                numericUpDown10.Value = 10000;
                numericUpDown11.Value = 0;
                numericUpDown12.Value = 5000;
            }
        }

        private void UpdateInfo()
        {
            numericUpDown0.Enabled = solCustomRadioButton.Checked;
            numericUpDown1.Enabled = solCustomRadioButton.Checked;
            numericUpDown2.Enabled = solCustomRadioButton.Checked;
            numericUpDown3.Enabled = solCustomRadioButton.Checked;
            numericUpDown4.Enabled = solCustomRadioButton.Checked;

            numericUpDown10.Enabled = iderCustomRadioButton.Checked;
            numericUpDown11.Enabled = iderCustomRadioButton.Checked;
            numericUpDown12.Enabled = iderCustomRadioButton.Checked;
        }

        private void solCustomRadioButton_CheckedChanged(object sender, EventArgs e)
        {
            UpdateInfo();
        }

        private void okButton_Click(object sender, EventArgs e)
        {
            Application.UserAppDataRegistry.SetValue("SOL-Timeout", solCustomRadioButton.Checked.ToString());
            Application.UserAppDataRegistry.SetValue("SOL-Timeout-1", numericUpDown0.Value.ToString());
            Application.UserAppDataRegistry.SetValue("SOL-Timeout-2", numericUpDown1.Value.ToString());
            Application.UserAppDataRegistry.SetValue("SOL-Timeout-3", numericUpDown2.Value.ToString());
            Application.UserAppDataRegistry.SetValue("SOL-Timeout-4", numericUpDown3.Value.ToString());
            Application.UserAppDataRegistry.SetValue("SOL-Timeout-5", numericUpDown4.Value.ToString());

            Application.UserAppDataRegistry.SetValue("IDER-Timeout", iderCustomRadioButton.Checked.ToString());
            Application.UserAppDataRegistry.SetValue("IDER-Timeout-1", numericUpDown10.Value.ToString());
            Application.UserAppDataRegistry.SetValue("IDER-Timeout-2", numericUpDown11.Value.ToString());
            Application.UserAppDataRegistry.SetValue("IDER-Timeout-3", numericUpDown12.Value.ToString());

            ManageabilityStack.AmtSystem.HttpTimeout = (int)httpTimeoutNumericUpDown.Value;

            Properties.Settings.Default.WsmanSupport = wsmanSupportCheckBox.Checked;
            Properties.Settings.Default.Save();

            DialogResult = DialogResult.OK;
        }
    }
}
