﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using ManageabilityStack;

namespace ManageabilityCommanderTool
{
    public partial class AuditLogStoragePolicyForm : Form
    {
        private AmtAuditLog.AmtStoragePolicyType storagePolicy;
        private uint threshold;

        public AmtAuditLog.AmtStoragePolicyType StoragePolicy
        {
            get { return this.storagePolicy; }
            set { this.storagePolicy = value; }
        }

        public uint Threshold
        {
            get { return this.threshold; }
            set { this.threshold = value; }
        }

        public AuditLogStoragePolicyForm()
        {
            InitializeComponent();
        }

        private void AuditLogStoragePolicyForm_Load(object sender, EventArgs e)
        {
            if (this.StoragePolicy == AmtAuditLog.AmtStoragePolicyType.NO_ROLL_OVER)
            {
                this.noRollOverRadioButton.Checked = true;
                this.thresholdLabel.Enabled = false;
                this.thresholdLabel.Enabled = false;
                this.thresholdNumericUpDown.Enabled = false;
            }
            else if (this.StoragePolicy == AmtAuditLog.AmtStoragePolicyType.ROLL_OVER)
            {
                this.rollOverRadioButton.Checked = true;
                this.thresholdLabel.Enabled = false;
                this.thresholdLabel.Enabled = false;
                this.thresholdNumericUpDown.Enabled = false;
            }
            else if (this.StoragePolicy == AmtAuditLog.AmtStoragePolicyType.RESTRICTED_ROLL_OVER)
            {
                this.restrictedRollOverRadioButton.Checked = true;
                this.thresholdLabel.Enabled = true;
                this.thresholdLabel.Enabled = true;
                this.thresholdNumericUpDown.Enabled = true;
            }
            this.thresholdNumericUpDown.Value = Math.Max(this.Threshold, this.thresholdNumericUpDown.Minimum);
        }

        private void noRollOverRadioButton_CheckedChanged(object sender, EventArgs e)
        {
            this.StoragePolicy = AmtAuditLog.AmtStoragePolicyType.NO_ROLL_OVER;
            this.thresholdLabel.Enabled = false;
            this.thresholdNumericUpDown.Enabled = false;
        }

        private void rollOverRadioButton_CheckedChanged(object sender, EventArgs e)
        {
            this.StoragePolicy = AmtAuditLog.AmtStoragePolicyType.ROLL_OVER;
            this.thresholdLabel.Enabled = false;
            this.thresholdNumericUpDown.Enabled = false;
        }

        private void restrictedRollOverRadioButton_CheckedChanged(object sender, EventArgs e)
        {
            this.StoragePolicy = AmtAuditLog.AmtStoragePolicyType.RESTRICTED_ROLL_OVER;
            this.thresholdLabel.Enabled = true;
            this.thresholdNumericUpDown.Enabled = true;
        }

        private void thresholdNumericUpDown_ValueChanged(object sender, EventArgs e)
        {
            // The threshold value must be between 1 and 100.
            this.Threshold = Math.Max((uint)this.thresholdNumericUpDown.Value, 1);
            this.Threshold = Math.Min((uint)this.thresholdNumericUpDown.Value, 100);
            this.thresholdNumericUpDown.Value = this.Threshold;
        }

        private void okButton_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.OK;
            this.Close();
        }

        private void cancelButton_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
            this.Close();
        }
    }
}
