﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ManageabilityCommanderTool
{
    public partial class EditTLSTrustedCNsForm : Form
    {
        #region Private Members

        private string[] _trustedCNs = null;

        #endregion

        #region Constructors

        private EditTLSTrustedCNsForm()
        {
            InitializeComponent();
        }

        public EditTLSTrustedCNsForm(string[] trustedCNs)
        {
            if (trustedCNs != null)
                TrustedCNs = trustedCNs;
            else TrustedCNs = new string[0];

            InitializeComponent();
        }

        #endregion

        #region Public Properties

        public string[] TrustedCNs
        {
            get { return _trustedCNs; }
            set { _trustedCNs = value; }
        }

        #endregion

        #region Private Methods

        private void EditTLSTrustedCNsForm_Load(object sender, EventArgs e)
        {
            foreach (string trustedCN in TrustedCNs)
                trustedCnListBox.Items.Add(trustedCN);

            if (trustedCnListBox.Items.Count > 0)
                addButton.Enabled = true;
        }

        private void fqdnListBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (trustedCnListBox.SelectedItems.Count > 0)
            {
                removeButton.Enabled = true;
                string selectedCN = (string)trustedCnListBox.SelectedItem;
                trustedCnTextBox.Text = selectedCN;
            }
            else
                removeButton.Enabled = false;
        }

        private void fqdnTextBox_TextChanged(object sender, EventArgs e)
        {
            if (trustedCnTextBox.Text.Length > 0)
                addButton.Enabled = true;
            else
                addButton.Enabled = false;
        }

        private void addButton_Click(object sender, EventArgs e)
        {
            trustedCnListBox.Items.Add(trustedCnTextBox.Text);
            trustedCnTextBox.Clear();
            addButton.Enabled = false;
        }

        private void removeButton_Click(object sender, EventArgs e)
        {
            while (trustedCnListBox.SelectedItems.Count > 0)
            {
                trustedCnListBox.Items.Remove(trustedCnListBox.SelectedItem);
            }
            removeButton.Enabled = false;
        }

        private void okButton_Click(object sender, EventArgs e)
        {
            TrustedCNs = new string[trustedCnListBox.Items.Count];
            trustedCnListBox.Items.CopyTo(_trustedCNs, 0);
            DialogResult = DialogResult.OK;
            Close();
        }

        private void cancelButton_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Cancel;
            Close();
        }

        #endregion
    }
}
