// =============================================================================
// Copyright 2008-2011. Intel Corporation All Rights Reserved.
//
// The source code contained or described herein and all documents related to 
// the source code ("Material") are owned by Intel Corporation or its suppliers 
// or licensors. Title to the Material remains with Intel Corporation or its 
// suppliers and licensors. The Material may contain trade secrets and 
// proprietary and confidential information of Intel Corporation and its 
// suppliers and licensors, and is protected by worldwide copyright and trade 
// secret laws and treaty provisions. No part of the Material may be used, 
// copied, reproduced, modified, published, uploaded, posted, transmitted, 
// distributed, or disclosed in any way without Intels prior express written 
// permission. 
//
// No license under any patent, copyright, trade secret or other intellectual 
// property right is granted to or conferred upon you by disclosure or delivery 
// of the Materials, either expressly, by implication, inducement, estoppel or 
// otherwise. Any license under such intellectual property rights must be 
// express and approved by Intel in writing.
// =============================================================================
using System;
using System.Data;
using System.Text;
using System.Drawing;
using System.Windows.Forms;
using System.ComponentModel;
using System.Collections.Generic;
using ManageabilityStack;

namespace ManageabilityCommanderTool
{
    public partial class FullUnprovisionForm : Form
    {
        private AmtSystem computer;

        public FullUnprovisionForm(AmtSystem computer)
        {
            this.computer = computer;
            InitializeComponent();
        }

        private void okButton_Click(object sender, EventArgs e)
        {
            AmtSecurityAdmin.ProvisioningMode m = AmtSecurityAdmin.ProvisioningMode.Current;
            if (radioButton2.Checked) m = AmtSecurityAdmin.ProvisioningMode.SmallBusiness;
            if (radioButton3.Checked) m = AmtSecurityAdmin.ProvisioningMode.Enterprise;
            computer.SecurityAdmin.Unprovision(m);
            this.DialogResult = DialogResult.OK;
        }

        private void FullUnprovisionForm_Load(object sender, EventArgs e)
        {
            if (this.Owner != null) Icon = Owner.Icon;
        }
    }
}
