// =============================================================================
// Copyright 2008-2011. Intel Corporation All Rights Reserved.
//
// The source code contained or described herein and all documents related to 
// the source code ("Material") are owned by Intel Corporation or its suppliers 
// or licensors. Title to the Material remains with Intel Corporation or its 
// suppliers and licensors. The Material may contain trade secrets and 
// proprietary and confidential information of Intel Corporation and its 
// suppliers and licensors, and is protected by worldwide copyright and trade 
// secret laws and treaty provisions. No part of the Material may be used, 
// copied, reproduced, modified, published, uploaded, posted, transmitted, 
// distributed, or disclosed in any way without Intels prior express written 
// permission. 
//
// No license under any patent, copyright, trade secret or other intellectual 
// property right is granted to or conferred upon you by disclosure or delivery 
// of the Materials, either expressly, by implication, inducement, estoppel or 
// otherwise. Any license under such intellectual property rights must be 
// express and approved by Intel in writing.
// =============================================================================
using System;
using System.Data;
using System.Text;
using System.Drawing;
using System.Windows.Forms;
using System.ComponentModel;
using System.Collections.Generic;
using ManageabilityStack;

namespace ManageabilityCommanderTool
{
    public partial class SensorsForm : Form
    {
        AmtSystem computer;

        public SensorsForm(AmtSystem computer)
        {
            this.computer = computer;

            InitializeComponent();
        }

        private void SensorsForm_Load(object sender, EventArgs e)
        {
            if (this.Owner != null) Icon = Owner.Icon; 
            subscriptionsListView.BeginUpdate();
            subscriptionsListView.Items.Clear();
            AmtEventSensor[] sensors = computer.Events.GetSensors();
            foreach (AmtEventSensor sensor in sensors)
            {
                ListViewItem l = new ListViewItem(new string[] { sensor.EntityStr });
                l.Tag = sensor;
                subscriptionsListView.Items.Add(l);
            }
            subscriptionsListView.EndUpdate();
        }

        private void sensorsListView_SelectedIndexChanged(object sender, EventArgs e)
        {
            UpdateInfo();
        }

        private void UpdateInfo()
        {
            if (subscriptionsListView.SelectedItems.Count != 1)
            {
                sensorLabel1.Text = "";
                sensorLabel2.Text = "";
                sensorLabel3.Text = "";
                return;
            }

            AmtEventSensor sensor = (AmtEventSensor)subscriptionsListView.SelectedItems[0].Tag;

            sensorLabel1.Text = sensor.EntityStr;
            sensorLabel2.Text = sensor.EventSensorType.ToString() + " - " + sensor.EventSensorTypeStr;
            sensorLabel3.Text = AmtEventData.GetEventSeverityString(sensor.EventSeverity);

        }
    }
}
