// =============================================================================
// Copyright 2008-2011. Intel Corporation All Rights Reserved.
//
// The source code contained or described herein and all documents related to 
// the source code ("Material") are owned by Intel Corporation or its suppliers 
// or licensors. Title to the Material remains with Intel Corporation or its 
// suppliers and licensors. The Material may contain trade secrets and 
// proprietary and confidential information of Intel Corporation and its 
// suppliers and licensors, and is protected by worldwide copyright and trade 
// secret laws and treaty provisions. No part of the Material may be used, 
// copied, reproduced, modified, published, uploaded, posted, transmitted, 
// distributed, or disclosed in any way without Intels prior express written 
// permission. 
//
// No license under any patent, copyright, trade secret or other intellectual 
// property right is granted to or conferred upon you by disclosure or delivery 
// of the Materials, either expressly, by implication, inducement, estoppel or 
// otherwise. Any license under such intellectual property rights must be 
// express and approved by Intel in writing.
// =============================================================================
using System;
using System.Data;
using System.Text;
using System.Drawing;
using System.Windows.Forms;
using System.ComponentModel;
using System.Collections.Generic;

namespace ManageabilityConnectorTool
{
    public partial class AutoTestingForm : Form
    {
        public AutoTestingForm()
        {
            InitializeComponent();
        }

        private void UpdateInfo()
        {
            connectPeriodicNumericUpDown.Enabled = connectCheckBox.Checked;
            disconnectPeriodicNumericUpDown.Enabled = disconnectCheckBox.Checked; 
        }

        private void AutoTestingForm_Load(object sender, EventArgs e)
        {
            connectCheckBox.Checked = Properties.Settings.Default.AutoConnection;
            connectPeriodicNumericUpDown.Value = Properties.Settings.Default.AutoConnectionTimeout;
            disconnectCheckBox.Checked = Properties.Settings.Default.AutoDisconnect;
            disconnectPeriodicNumericUpDown.Value = Properties.Settings.Default.AutoDisconnectTimeout;
            UpdateInfo();
        }

        private void okButton_Click(object sender, EventArgs e)
        {
            Properties.Settings.Default.AutoConnection = connectCheckBox.Checked;
            Properties.Settings.Default.AutoConnectionTimeout = (int)connectPeriodicNumericUpDown.Value;
            Properties.Settings.Default.AutoDisconnect = disconnectCheckBox.Checked;
            Properties.Settings.Default.AutoDisconnectTimeout = (int)disconnectPeriodicNumericUpDown.Value;
            Properties.Settings.Default.Save();
            DialogResult = DialogResult.OK;
        }

        private void connectCheckBox_CheckedChanged(object sender, EventArgs e)
        {
            UpdateInfo();
        }

        private void disconnectCheckBox_CheckedChanged(object sender, EventArgs e)
        {
            UpdateInfo();
        }
    }
}
