// =============================================================================
// Copyright 2008-2011. Intel Corporation All Rights Reserved.
//
// The source code contained or described herein and all documents related to 
// the source code ("Material") are owned by Intel Corporation or its suppliers 
// or licensors. Title to the Material remains with Intel Corporation or its 
// suppliers and licensors. The Material may contain trade secrets and 
// proprietary and confidential information of Intel Corporation and its 
// suppliers and licensors, and is protected by worldwide copyright and trade 
// secret laws and treaty provisions. No part of the Material may be used, 
// copied, reproduced, modified, published, uploaded, posted, transmitted, 
// distributed, or disclosed in any way without Intels prior express written 
// permission. 
//
// No license under any patent, copyright, trade secret or other intellectual 
// property right is granted to or conferred upon you by disclosure or delivery 
// of the Materials, either expressly, by implication, inducement, estoppel or 
// otherwise. Any license under such intellectual property rights must be 
// express and approved by Intel in writing.
// =============================================================================
using System;
using System.Data;
using System.Text;
using System.Drawing;
using System.Windows.Forms;
using System.ComponentModel;
using System.Collections.Generic;
using ManageabilityStack;

namespace ManageabilityConnectorTool
{
    public partial class ManagementProfilesForm : Form
    {
        private HeciWrapper ManagementEngine;
        private MspProfile[] profiles;
        private string mspname = null;

        public ManagementProfilesForm(HeciWrapper ManagementEngine, MspProfile[] profiles)
        {
            this.ManagementEngine = ManagementEngine;
            this.profiles = profiles;
            if (ManagementEngine != null && ManagementEngine.ClientConnect != null)
            {
                EnrollementState e = ManagementEngine.ClientConnect.GetEnrollmentState();
                if (e != null) mspname = e.MspName;
            }
            InitializeComponent();
        }

        private void ManagementProfilesForm_Load(object sender, EventArgs e)
        {
            if (this.Owner != null) Icon = Owner.Icon; 
            if (profiles.Length >= 1)
            {
                providerLabel1.Text = profiles[0].FriendlyName;
                managementLabel1.Text = profiles[0].GatewayFqdn + ":" + profiles[0].Port.ToString();
                timeoutLabel1.Text = string.Format("{0} seconds", profiles[0].InactivityTimeout);
                panel1.Visible = true;
                if (mspname.Equals(providerLabel1.Text)) panel1.BackColor = Color.LightGray;
            }

            if (profiles.Length >= 2)
            {
                providerLabel2.Text = profiles[1].FriendlyName;
                managementLabel2.Text = profiles[1].GatewayFqdn + ":" + profiles[1].Port.ToString();
                timeoutLabel2.Text = string.Format("{0} seconds", profiles[1].InactivityTimeout);
                panel2.Visible = true;
                if (mspname.Equals(providerLabel2.Text)) panel2.BackColor = Color.LightGray;
            }

            if (profiles.Length >= 3)
            {
                providerLabel3.Text = profiles[2].FriendlyName;
                managementLabel3.Text = profiles[2].GatewayFqdn + ":" + profiles[2].Port.ToString();
                timeoutLabel3.Text = string.Format("{0} seconds", profiles[2].InactivityTimeout);
                panel3.Visible = true;
                if (mspname.Equals(providerLabel3.Text)) panel3.BackColor = Color.LightGray;
            }

            if (profiles.Length >= 4)
            {
                providerLabel4.Text = profiles[3].FriendlyName;
                managementLabel4.Text = profiles[3].GatewayFqdn + ":" + profiles[3].Port.ToString();
                timeoutLabel4.Text = string.Format("{0} seconds", profiles[3].InactivityTimeout);
                panel4.Visible = true;
                if (mspname.Equals(providerLabel4.Text)) panel4.BackColor = Color.LightGray;
            }
        
        }

        private void closeButton_Click(object sender, EventArgs e)
        {
            Close();
        }
    }
}
