// =============================================================================
// Copyright 2008-2011. Intel Corporation All Rights Reserved.
//
// The source code contained or described herein and all documents related to 
// the source code ("Material") are owned by Intel Corporation or its suppliers 
// or licensors. Title to the Material remains with Intel Corporation or its 
// suppliers and licensors. The Material may contain trade secrets and 
// proprietary and confidential information of Intel Corporation and its 
// suppliers and licensors, and is protected by worldwide copyright and trade 
// secret laws and treaty provisions. No part of the Material may be used, 
// copied, reproduced, modified, published, uploaded, posted, transmitted, 
// distributed, or disclosed in any way without Intels prior express written 
// permission. 
//
// No license under any patent, copyright, trade secret or other intellectual 
// property right is granted to or conferred upon you by disclosure or delivery 
// of the Materials, either expressly, by implication, inducement, estoppel or 
// otherwise. Any license under such intellectual property rights must be 
// express and approved by Intel in writing.
// =============================================================================
using System;
using System.Net;
using System.Data;
using System.Text;
using System.Drawing;
using System.Windows.Forms;
using System.ComponentModel;
using System.Collections.Generic;

namespace ManageabilityControls
{
    public partial class HeciBridgeConnectionForm : Form
    {
        private string hoststr;
        private ushort port;

        public HeciBridgeConnectionForm()
        {
            InitializeComponent();
        }

        private void okButton_Click(object sender, EventArgs e)
        {
            Properties.Settings.Default.HeciBridgeHost = hostnameTextBox.Text;
            Properties.Settings.Default.Save();
            DialogResult = DialogResult.OK;
        }

        private void hostnameTextBox_TextChanged(object sender, EventArgs e)
        {
            int i = hostnameTextBox.Text.IndexOf(':');
            if (i < 1)
            {
                okButton.Enabled = false;
                return;
            }

            hoststr = hostnameTextBox.Text.Substring(0, i);
            string portstr = hostnameTextBox.Text.Substring(i+1);
            if (ushort.TryParse(portstr, out port) == false || port == 0)
            {
                okButton.Enabled = false;
                return;
            }

            okButton.Enabled = (hoststr.Length != 0);
        }

        public string Hostname
        {
            get
            {
                hostnameTextBox_TextChanged(this, null);
                return hoststr;
            }
        }

        public ushort Port
        {
            get
            {
                hostnameTextBox_TextChanged(this, null);
                return port;
            }
        }

        private void SimulatorConnectionForm_Load(object sender, EventArgs e)
        {
            if (hostnameTextBox.Text.Length == 0) hostnameTextBox.Text = Properties.Settings.Default.HeciBridgeHost;
        }
    }
}
