// =============================================================================
// Copyright 2008-2011. Intel Corporation All Rights Reserved.
//
// The source code contained or described herein and all documents related to 
// the source code ("Material") are owned by Intel Corporation or its suppliers 
// or licensors. Title to the Material remains with Intel Corporation or its 
// suppliers and licensors. The Material may contain trade secrets and 
// proprietary and confidential information of Intel Corporation and its 
// suppliers and licensors, and is protected by worldwide copyright and trade 
// secret laws and treaty provisions. No part of the Material may be used, 
// copied, reproduced, modified, published, uploaded, posted, transmitted, 
// distributed, or disclosed in any way without Intels prior express written 
// permission. 
//
// No license under any patent, copyright, trade secret or other intellectual 
// property right is granted to or conferred upon you by disclosure or delivery 
// of the Materials, either expressly, by implication, inducement, estoppel or 
// otherwise. Any license under such intellectual property rights must be 
// express and approved by Intel in writing.
// =============================================================================
using System;
using System.Data;
using System.Text;
using System.Drawing;
using System.Windows.Forms;
using System.ComponentModel;
using System.Collections.Generic;

namespace ManageabilityControls
{
    public partial class PasswordControl : UserControl
    {
        public event System.EventHandler PasswordChanged;

        public PasswordControl()
        {
            InitializeComponent();
            passwordTextBox.PasswordChar = Properties.Resources.PasswordChar[0];
        }

        protected override void OnTextChanged(EventArgs e)
        {
            base.OnTextChanged(e);
            passwordTextBox.Text = Text;
        }

        protected override void  OnEnabledChanged(EventArgs e)
        {
 	        base.OnEnabledChanged(e);
            hideCheckBox.Enabled = Enabled;
            passwordTextBox.Enabled = Enabled;
        }

        public char PasswordChar
        {
            get { return passwordTextBox.PasswordChar; }
            set { passwordTextBox.PasswordChar = value; }
        }

        public string HideText
        {
            get { return hideCheckBox.Text; }
            set { hideCheckBox.Text = value; }
        }

        public override string Text
        {
            get { return passwordTextBox.Text; }
            set { passwordTextBox.Text = value; }
        }

        public bool Hidden
        {
            get { return hideCheckBox.Checked; }
            set { hideCheckBox.Checked = value; }
        }

        private void hideCheckBox_CheckedChanged(object sender, EventArgs e)
        {
            if (hideCheckBox.Checked)
            {
                passwordTextBox.PasswordChar = Properties.Resources.PasswordChar[0];
            }
            else
            {
                passwordTextBox.PasswordChar = '\0';
            }
        }

        private void passwordTextBox_TextChanged(object sender, EventArgs e)
        {
            if (PasswordChanged != null) PasswordChanged(this, null);
        }

    }
}
