// =============================================================================
// Copyright 2008-2011. Intel Corporation All Rights Reserved.
//
// The source code contained or described herein and all documents related to 
// the source code ("Material") are owned by Intel Corporation or its suppliers 
// or licensors. Title to the Material remains with Intel Corporation or its 
// suppliers and licensors. The Material may contain trade secrets and 
// proprietary and confidential information of Intel Corporation and its 
// suppliers and licensors, and is protected by worldwide copyright and trade 
// secret laws and treaty provisions. No part of the Material may be used, 
// copied, reproduced, modified, published, uploaded, posted, transmitted, 
// distributed, or disclosed in any way without Intels prior express written 
// permission. 
//
// No license under any patent, copyright, trade secret or other intellectual 
// property right is granted to or conferred upon you by disclosure or delivery 
// of the Materials, either expressly, by implication, inducement, estoppel or 
// otherwise. Any license under such intellectual property rights must be 
// express and approved by Intel in writing.
// =============================================================================
using System;
using System.Data;
using System.Text;
using System.Drawing;
using System.Windows.Forms;
using System.ComponentModel;
using System.Collections.Generic;
using ManageabilityStack;

namespace ManageabilityControls
{
    public partial class StorageAddGroupMemberForm : Form
    {
        private LocalStorageInfo Store;
        private AmtStorageApplication App;

        public StorageAddGroupMemberForm(LocalStorageInfo store, AmtStorageApplication app)
        {
            Store = store;
            App = app;
            InitializeComponent();
        }

        public uint Member
        {
            get
            {
                return (uint)((Utils.DropDownItem)permissionComboBox.SelectedItem).Handle;
            }
        }

        private void StorageAddGroupMemberForm_Load(object sender, EventArgs e)
        {
            if (this.Owner != null) Icon = Owner.Icon; 
            permissionComboBox.Items.Add(new Utils.DropDownItem("Same Enterprise, Vendor, Application", -16, null));
            permissionComboBox.Items.Add(new Utils.DropDownItem("Same Enterprise & Vendor", -15, null));
            if (Store != null)
            {
                AmtStorageApplication[] apps = Store.GetApplications();
                foreach (AmtStorageApplication app in apps)
                {
                    permissionComboBox.Items.Add(new Utils.DropDownItem(string.Format("{0}, {1} (Handle {2})", app.Vendor, app.Application, app.Handle), (int)(app.Handle), null));
                }
            }
            permissionComboBox.SelectedIndex = 0;
        }

        private void okButton_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.OK;
        }

    }
}
