// =============================================================================
// Copyright 2008-2011. Intel Corporation All Rights Reserved.
//
// The source code contained or described herein and all documents related to 
// the source code ("Material") are owned by Intel Corporation or its suppliers 
// or licensors. Title to the Material remains with Intel Corporation or its 
// suppliers and licensors. The Material may contain trade secrets and 
// proprietary and confidential information of Intel Corporation and its 
// suppliers and licensors, and is protected by worldwide copyright and trade 
// secret laws and treaty provisions. No part of the Material may be used, 
// copied, reproduced, modified, published, uploaded, posted, transmitted, 
// distributed, or disclosed in any way without Intels prior express written 
// permission. 
//
// No license under any patent, copyright, trade secret or other intellectual 
// property right is granted to or conferred upon you by disclosure or delivery 
// of the Materials, either expressly, by implication, inducement, estoppel or 
// otherwise. Any license under such intellectual property rights must be 
// express and approved by Intel in writing.
// =============================================================================
using System;
using System.Net;
using System.Data;
using System.Text;
using System.Drawing;
using System.Net.Sockets;
using System.Windows.Forms;
using System.ComponentModel;
using System.Collections.Generic;

namespace ManageabilityDirectorTool
{
    public partial class AddressResolveForm : Form
    {
        public AddressResolveForm()
        {
            InitializeComponent();
        }

        private void closeButton_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void lookupButton_Click(object sender, EventArgs e)
        {
            mainTextBox.Clear();
            IPAddress addr = null;
            try
            {
                addr = IPAddress.Parse(nameTextBox.Text);
            }
            catch (Exception) { }
            if (addr != null)
            {
                mainTextBox.AppendText(string.Format(Properties.Resources.ParsedIpAddress + "\r\n", addr.ToString()));
            }
            else
            {
                mainTextBox.AppendText(string.Format(Properties.Resources.ParsedHostname + "\r\n", nameTextBox.Text));
            }

            IPHostEntry entry = null;
            try
            {
                entry = System.Net.Dns.GetHostEntry(nameTextBox.Text);
            }
            catch (Exception) { }
            if (entry != null)
            {
                mainTextBox.AppendText(string.Format(Properties.Resources.ResolvedHostname + "\r\n", entry.HostName));
                int i = 1;
                foreach (string s in entry.Aliases)
                {
                    mainTextBox.AppendText(string.Format(Properties.Resources.ResolvedAlias + "\r\n", i, s));
                    i++;
                }
                mainTextBox.AppendText("\r\n");
                i = 1;
                foreach (IPAddress a in entry.AddressList)
                {
                    mainTextBox.AppendText(string.Format(Properties.Resources.ResolvedAddress + "\r\n", i, a.ToString()));
                    i++;
                }
            }
            else
            {
                mainTextBox.AppendText(Properties.Resources.NoHostEntriesFound + "\r\n");
            }
        }

        private void AddressResolveForm_Load(object sender, EventArgs e)
        {
            if (this.Owner != null) Icon = Owner.Icon;
        }
    }
}
