// =============================================================================
// Copyright 2008-2011. Intel Corporation All Rights Reserved.
//
// The source code contained or described herein and all documents related to 
// the source code ("Material") are owned by Intel Corporation or its suppliers 
// or licensors. Title to the Material remains with Intel Corporation or its 
// suppliers and licensors. The Material may contain trade secrets and 
// proprietary and confidential information of Intel Corporation and its 
// suppliers and licensors, and is protected by worldwide copyright and trade 
// secret laws and treaty provisions. No part of the Material may be used, 
// copied, reproduced, modified, published, uploaded, posted, transmitted, 
// distributed, or disclosed in any way without Intels prior express written 
// permission. 
//
// No license under any patent, copyright, trade secret or other intellectual 
// property right is granted to or conferred upon you by disclosure or delivery 
// of the Materials, either expressly, by implication, inducement, estoppel or 
// otherwise. Any license under such intellectual property rights must be 
// express and approved by Intel in writing.
// =============================================================================
using System;
using System.Data;
using System.Text;
using System.Drawing;
using System.Windows.Forms;
using System.ComponentModel;
using System.Collections.Generic;
using System.Security.Cryptography;
using System.Security.Cryptography.X509Certificates;

namespace ManageabilityDirectorTool
{
    public partial class CertificateViewerForm : Form
    {
        private X509Certificate2[] certificates;

        public CertificateViewerForm(X509Certificate2[] certs)
        {
            certificates = certs;
            InitializeComponent();
        }

        private void closeButton_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void CertificateViewerForm_Load(object sender, EventArgs e)
        {
            foreach (X509Certificate2 cert in certificates)
            {
                ListViewItem l = new ListViewItem(new string[] { ManageabilityCommanderTool.CertificateOperations.GetCertificateString(cert.Subject) });
                l.Tag = cert;
                certListView.Items.Add(l);
            }
            UpdateInfo();
        }

        private void certListView_SelectedIndexChanged(object sender, EventArgs e)
        {
            UpdateInfo();
        }

        private void UpdateInfo()
        {
            viewButton.Enabled = (certListView.SelectedItems.Count > 0);
        }

        private void viewButton_Click(object sender, EventArgs e)
        {
            if (certListView.SelectedItems.Count != 1) return;
            X509Certificate2 cert = (X509Certificate2)certListView.SelectedItems[0].Tag;
            X509Certificate2UI.DisplayCertificate(cert, Handle);
        }
    }
}
