// =============================================================================
// Copyright 2008-2011. Intel Corporation All Rights Reserved.
//
// The source code contained or described herein and all documents related to 
// the source code ("Material") are owned by Intel Corporation or its suppliers 
// or licensors. Title to the Material remains with Intel Corporation or its 
// suppliers and licensors. The Material may contain trade secrets and 
// proprietary and confidential information of Intel Corporation and its 
// suppliers and licensors, and is protected by worldwide copyright and trade 
// secret laws and treaty provisions. No part of the Material may be used, 
// copied, reproduced, modified, published, uploaded, posted, transmitted, 
// distributed, or disclosed in any way without Intels prior express written 
// permission. 
//
// No license under any patent, copyright, trade secret or other intellectual 
// property right is granted to or conferred upon you by disclosure or delivery 
// of the Materials, either expressly, by implication, inducement, estoppel or 
// otherwise. Any license under such intellectual property rights must be 
// express and approved by Intel in writing.
// =============================================================================
using System;
using System.IO;
using System.Data;
using System.Text;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.ComponentModel;
using System.Collections.Generic;

namespace ManageabilityDirectorTool
{
    public partial class ExportSetupKeysForm : Form
    {
        private AmtProvisioningKey[] keys;

        public ExportSetupKeysForm(AmtProvisioningKey[] keys)
        {
            this.keys = keys;
            InitializeComponent();
        }

        private void ExportSetupKeysForm_Load(object sender, EventArgs e)
        {
            if (this.Owner != null) Icon = Owner.Icon; 
            radioButton2.Enabled = (keys.Length == 1);
        }

        private void okButton_Click(object sender, EventArgs e)
        {
            if (saveFileDialog.ShowDialog(this) == DialogResult.OK)
            {
                if (radioButton2.Checked)
                {
                    ArrayList list = new ArrayList();
                    for (int i=0;i<250;i++)
                    {
                        UsbSetupViewerForm.UsbFileRecord r = new UsbSetupViewerForm.UsbFileRecord(keys[0].Pid.Replace("-", ""), keys[0].Pps.Replace("-", ""), existingPasswordTextBox.Text, keys[0].AdminPassword);
                        list.Add(r);
                    }

                    UsbSetupViewerForm.UsbFile file = new UsbSetupViewerForm.UsbFile((UsbSetupViewerForm.UsbFileRecord[])list.ToArray(typeof(UsbSetupViewerForm.UsbFileRecord)), 1, 0);
                    byte[] usbFileBytes = file.GetBytes();
                    FileStream f = new FileStream(saveFileDialog.FileName, FileMode.Create);
                    f.Write(usbFileBytes, 0, usbFileBytes.Length);
                    f.Close();
                }
                else
                {
                    ArrayList list = new ArrayList();
                    foreach (AmtProvisioningKey k in keys)
                    {
                        UsbSetupViewerForm.UsbFileRecord r = new UsbSetupViewerForm.UsbFileRecord(k.Pid.Replace("-", ""), k.Pps.Replace("-", ""), existingPasswordTextBox.Text, k.AdminPassword);
                        list.Add(r);
                    }

                    UsbSetupViewerForm.UsbFile file = new UsbSetupViewerForm.UsbFile((UsbSetupViewerForm.UsbFileRecord[])list.ToArray(typeof(UsbSetupViewerForm.UsbFileRecord)), 1, 0);
                    byte[] usbFileBytes = file.GetBytes();
                    FileStream f = new FileStream(saveFileDialog.FileName, FileMode.Create);
                    f.Write(usbFileBytes, 0, usbFileBytes.Length);
                    f.Close();
                }
            }

            DialogResult = DialogResult.OK;
        }

        private void existingPasswordTextBox_TextChanged(object sender, EventArgs e)
        {
            UpdateInfo();
        }

        private void UpdateInfo()
        {
            okButton.Enabled = (existingPasswordTextBox.Text.Length > 0);
        }

    }
}
