// =============================================================================
// Copyright 2008-2011. Intel Corporation All Rights Reserved.
//
// The source code contained or described herein and all documents related to 
// the source code ("Material") are owned by Intel Corporation or its suppliers 
// or licensors. Title to the Material remains with Intel Corporation or its 
// suppliers and licensors. The Material may contain trade secrets and 
// proprietary and confidential information of Intel Corporation and its 
// suppliers and licensors, and is protected by worldwide copyright and trade 
// secret laws and treaty provisions. No part of the Material may be used, 
// copied, reproduced, modified, published, uploaded, posted, transmitted, 
// distributed, or disclosed in any way without Intels prior express written 
// permission. 
//
// No license under any patent, copyright, trade secret or other intellectual 
// property right is granted to or conferred upon you by disclosure or delivery 
// of the Materials, either expressly, by implication, inducement, estoppel or 
// otherwise. Any license under such intellectual property rights must be 
// express and approved by Intel in writing.
// =============================================================================
using System;
using System.Data;
using System.Text;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.ComponentModel;
using System.Collections.Generic;
using ManageabilityStack;

namespace ManageabilityDirectorTool
{
    public partial class SetProfileForm : Form
    {
        public SecurityTemplate SetSecurityTemplate;
        public ArrayList Machines = null;

        public SetProfileForm()
        {
            InitializeComponent();
        }

        private void SetTemplateForm_Load(object sender, EventArgs e)
        {
            machineListView.Items.Clear();
            machineListView.BeginUpdate();
            foreach (AmtSystem system in Machines)
            {
                int c = 1;
                if (system.State == AmtSystemObjState.Connected) c = 0;
                ListViewItem l = new ListViewItem(system.HostNameIdentity.DisplayName + Properties.Resources.DashSeperator + system.Username, c);
                l.Tag = system;
                machineListView.Items.Add(l);
            }
            machineListView.EndUpdate();
        }

        private void UpdateInfo()
        {
            int check = 0;
            foreach (ListViewItem l in machineListView.Items)
            {
                if (l.Checked == true) check++;
            }
            setButton.Enabled = (check > 0);
        }

        private void machineListView_ItemChecked(object sender, ItemCheckedEventArgs e)
        {
            UpdateInfo();
        }

        private void setButton_Click(object sender, EventArgs e)
        {
            foreach (ListViewItem l in machineListView.Items)
            {
                if (l.Checked == true)
                {
                    ArrayList setList = new ArrayList();

                    // Add security profile changes in pending list.
                    setList.Add(SetSecurityTemplate);

                    if (SetSecurityTemplate.AdminAclPassword != null)
                    {
                        // Add admin account settings change in pending list
                        setList.Add(new SecurityTemplateAdminChange(SetSecurityTemplate.AdminAclEntry, SetSecurityTemplate.AdminAclPassword));
                    }

                    ((AmtSystem)l.Tag).Tag = setList;
                }
            }
            Close();
        }
    }
}
