// =============================================================================
// Copyright 2008-2011. Intel Corporation All Rights Reserved.
//
// The source code contained or described herein and all documents related to 
// the source code ("Material") are owned by Intel Corporation or its suppliers 
// or licensors. Title to the Material remains with Intel Corporation or its 
// suppliers and licensors. The Material may contain trade secrets and 
// proprietary and confidential information of Intel Corporation and its 
// suppliers and licensors, and is protected by worldwide copyright and trade 
// secret laws and treaty provisions. No part of the Material may be used, 
// copied, reproduced, modified, published, uploaded, posted, transmitted, 
// distributed, or disclosed in any way without Intels prior express written 
// permission. 
//
// No license under any patent, copyright, trade secret or other intellectual 
// property right is granted to or conferred upon you by disclosure or delivery 
// of the Materials, either expressly, by implication, inducement, estoppel or 
// otherwise. Any license under such intellectual property rights must be 
// express and approved by Intel in writing.
// =============================================================================
using System;
using Microsoft.Win32;
using System.Windows.Forms;
using System.Collections.Generic;
using ManageabilityOutpostTool;

namespace ManageabilityOutpostServiceControlPanelTool
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main(string[] args)
        {
            CryptProtectClass cp = new CryptProtectClass(CryptProtectClass.cpStore.USE_MACHINE_STORE);
            string username = null;
            string password = null;
            bool saveonly = false;

            foreach (string arg in args)
            {
                if (arg.Length > 3 && string.Compare(arg.Substring(0, 3), "-l:", true) == 0) { try { System.Threading.Thread.CurrentThread.CurrentUICulture = new System.Globalization.CultureInfo(arg.Substring(3)); } catch (ArgumentException) { } }
                if (arg.Length > 3 && string.Compare(arg.Substring(0, 3), "-u:", true) == 0) username = arg.Substring(3);
                if (arg.Length > 3 && string.Compare(arg.Substring(0, 3), "-p:", true) == 0) password = arg.Substring(3);
                if (string.Compare(arg, "-saveonly", true) == 0) saveonly = true;
            }

            if (password != null)
            {
                byte[] bPassword = cp.Encrypt(cp.StrToByteArray(password), null);
                RegistryCtlClass.OutpostDataRegistry.SetValue("PasswordBin", bPassword, RegistryValueKind.Binary);
            }

            if (username != null)
            {
                RegistryCtlClass.OutpostDataRegistry.SetValue("Username", username);
            }

            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);

            try
            {
                Application.UserAppDataRegistry.GetValue("SystemsList", "");
            }
            catch (System.Security.SecurityException)
            {
                MessageBox.Show(
                    Properties.Resources.Program_MsgBox_0,
                    Properties.Resources.Program_MsgBox_1,
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

            if (saveonly == false)
            {
                Application.Run(new MainForm());
            }
        }
    }
}
