// =============================================================================
// Copyright 2008-2011. Intel Corporation All Rights Reserved.
//
// The source code contained or described herein and all documents related to 
// the source code ("Material") are owned by Intel Corporation or its suppliers 
// or licensors. Title to the Material remains with Intel Corporation or its 
// suppliers and licensors. The Material may contain trade secrets and 
// proprietary and confidential information of Intel Corporation and its 
// suppliers and licensors, and is protected by worldwide copyright and trade 
// secret laws and treaty provisions. No part of the Material may be used, 
// copied, reproduced, modified, published, uploaded, posted, transmitted, 
// distributed, or disclosed in any way without Intels prior express written 
// permission. 
//
// No license under any patent, copyright, trade secret or other intellectual 
// property right is granted to or conferred upon you by disclosure or delivery 
// of the Materials, either expressly, by implication, inducement, estoppel or 
// otherwise. Any license under such intellectual property rights must be 
// express and approved by Intel in writing.
// =============================================================================
using System;
using System.Data;
using System.Text;
using System.Drawing;
using System.Windows.Forms;
using System.ComponentModel;
using System.Collections.Generic;
using ManageabilityStack;

namespace ManageabilityOutpostTool
{
    public partial class AddStorageApplicationForm : Form
    {
        public AddStorageApplicationForm()
        {
            InitializeComponent();
        }

        public string Enterprise {get { return enterpriseTextBox.Text; }}
        public string Vendor { get { return vendorTextBox.Text; } }
        public string AppName { get { return applicationTextBox.Text; } }
        public Guid UUID { get { return new Guid(uuidTextBox.Text); } }

        private void UpdateInfo()
        {
            bool ok = true;
            if (enterpriseTextBox.Text.Length == 0) ok = false;
            if (vendorTextBox.Text.Length == 0) ok = false;
            if (applicationTextBox.Text.Length == 0) ok = false;

            try
            {
                new Guid(uuidTextBox.Text);
            }
            catch (Exception)
            {
                ok = false;
            }

            okButton.Enabled = ok;
        }

        private void enterpriseTextBox_TextChanged(object sender, EventArgs e)
        {
            UpdateInfo();
        }

        private void okButton_Click(object sender, EventArgs e)
        {
            Application.UserAppDataRegistry.SetValue("StorageEnterprise", enterpriseTextBox.Text);
            Application.UserAppDataRegistry.SetValue("StorageVendor", vendorTextBox.Text);
            Application.UserAppDataRegistry.SetValue("StorageApplication", applicationTextBox.Text);
            Application.UserAppDataRegistry.SetValue("StorageUUID", uuidTextBox.Text);

            DialogResult = DialogResult.OK;
        }

        private void AddStorageApplicationForm_Load(object sender, EventArgs e)
        {
            enterpriseTextBox.Text = (string)Application.UserAppDataRegistry.GetValue("StorageEnterprise", enterpriseTextBox.Text);
            vendorTextBox.Text = (string)Application.UserAppDataRegistry.GetValue("StorageVendor", vendorTextBox.Text);
            applicationTextBox.Text = (string)Application.UserAppDataRegistry.GetValue("StorageApplication", applicationTextBox.Text);
            uuidTextBox.Text = (string)Application.UserAppDataRegistry.GetValue("StorageUUID", uuidTextBox.Text);
            UpdateInfo();
        }

    }
}
