// =============================================================================
// Copyright 2008-2011. Intel Corporation All Rights Reserved.
//
// The source code contained or described herein and all documents related to 
// the source code ("Material") are owned by Intel Corporation or its suppliers 
// or licensors. Title to the Material remains with Intel Corporation or its 
// suppliers and licensors. The Material may contain trade secrets and 
// proprietary and confidential information of Intel Corporation and its 
// suppliers and licensors, and is protected by worldwide copyright and trade 
// secret laws and treaty provisions. No part of the Material may be used, 
// copied, reproduced, modified, published, uploaded, posted, transmitted, 
// distributed, or disclosed in any way without Intels prior express written 
// permission. 
//
// No license under any patent, copyright, trade secret or other intellectual 
// property right is granted to or conferred upon you by disclosure or delivery 
// of the Materials, either expressly, by implication, inducement, estoppel or 
// otherwise. Any license under such intellectual property rights must be 
// express and approved by Intel in writing.
// =============================================================================
using System;
using System.Text;
using System.Collections.Generic;
using System.Runtime.InteropServices;

namespace ManageabilityOutpostTool
{
    public class DevDriCtlClass
    {
        [DllImport("cfgmgr32.dll", ExactSpelling = false, SetLastError = true)]
        static extern int CM_Locate_DevNode_Ex(ref IntPtr dH, string ID, uint ulFlg, IntPtr mH);

        [DllImport("cfgmgr32.dll", ExactSpelling = false, SetLastError = true)]
        static extern int CM_Reenumerate_DevNode_Ex(int dH, uint ulFlg, IntPtr mH);

        private const int CM_LOCATE_DEVNODE_NORMAL = 0x00000000;

        public static int cmdHWRescan()
        {
            int resualt = -1;
            IntPtr mHandle = IntPtr.Zero;
            IntPtr deviceRoot = IntPtr.Zero;

            if (CM_Locate_DevNode_Ex(ref deviceRoot, null, CM_LOCATE_DEVNODE_NORMAL, mHandle) != CR_SUCCESS)
            {
                return resualt;
            }

            if (CM_Reenumerate_DevNode_Ex(deviceRoot.ToInt32(), 0x00000000, mHandle) != CR_SUCCESS)
            {
                return resualt;
            }

            resualt = 0;

            return resualt;
        }

        [DllImport("setupapi.dll", CharSet = CharSet.Auto, SetLastError = true)]
        static extern bool SetupDiClassGuidsFromNameEx(
            string ClassName, ref Guid ClassGuidList, Int32 ClassGuidListSize, ref Int32 RequiredSize,
            string MachineName, IntPtr Reserved);

        [DllImport("setupapi.dll", CharSet = CharSet.Auto, SetLastError = true)]
        static extern IntPtr SetupDiGetClassDevsEx(
            ref Guid ClassGuid, string Enumerator, IntPtr hwndParent, Int32 Flags,
            IntPtr DeviceInfoSet, string MachineName, IntPtr Reserved);

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Auto)]
        struct SP_DEVINFO_LIST_DETAIL_DATA
        {
            public Int32 cbSize;
            public Guid ClassGuid;
            public IntPtr RemoteMachineHandle;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 260)]
            public string RemoteMachineName;
        }

        [DllImport("setupapi.dll", SetLastError = true)]
        static extern bool
            SetupDiGetDeviceInfoListDetail(
            IntPtr DeviceInfoSet, ref SP_DEVINFO_LIST_DETAIL_DATA DeviceInfoSetDetailData);

        [StructLayout(LayoutKind.Sequential)]
        struct SP_DEVINFO_DATA
        {
            public Int32 cbSize;
            public Guid ClassGuid;
            public Int32 DevInst;
            public IntPtr Reserved;
        }

        [DllImport("setupapi.dll", SetLastError = true)]
        static extern bool SetupDiEnumDeviceInfo(
            IntPtr DeviceInfoSet, Int32 MemberIndex, ref SP_DEVINFO_DATA DeviceInfoData);

        [DllImport("setupapi.dll", CharSet = CharSet.Auto, SetLastError = true)]
        static extern bool SetupDiGetDeviceRegistryProperty(
            IntPtr DeviceInfoSet, ref SP_DEVINFO_DATA DeviceInfoData,
            Int32 Property, ref Int32 PropertyRegDataType,
            byte[] PropertyBuffer, Int32 PropertyBufferSize,
            ref Int32 RequiredSize);

        /*[DllImport("setupapi.dll", CharSet = CharSet.Auto, SetLastError = true)]
        static extern bool SetupDiBuildClassInfoListEx(
            Int32 Flags, ref Guid[] ClassGuidList, Int32 ClassGuidListSize,
            ref Int32 RequiredSize, string MachineName, IntPtr Reserved);*/

        [DllImport("cfgmgr32.dll")]
        static extern UInt32 CM_Enumerate_Classes(
            UInt32 ulClassIndex, ref Guid ClassGuid, UInt32 ulFlags);

        [DllImport("setupapi.dll", CharSet = CharSet.Auto, SetLastError = true)]
        static extern bool SetupDiClassNameFromGuidEx(
            ref Guid ClassGuid, byte[] ClassName, Int32 ClassNameSize,
            ref Int32 RequiredSize, string MachineName, IntPtr Reserved);

        [DllImport("setupapi.dll", CharSet = CharSet.Auto, SetLastError = true)]
        static extern bool SetupDiGetClassDescriptionEx(
            ref Guid ClassGuid, byte[] ClassDescription, Int32 ClassDescriptionSize,
            ref Int32 RequiredSize, string MachineName, IntPtr Reserved);

        [DllImport("setupapi.dll", SetLastError = true)]
        static extern bool SetupDiDestroyDeviceInfoList(IntPtr DeviceInfoSet);

        [DllImport("setupapi.dll")]
        static extern bool SetupDiLoadClassIcon(
            ref Guid ClassGuid, ref IntPtr LargeIcon, ref int MiniIconIndex);

        [StructLayout(LayoutKind.Sequential)]
        struct SP_CLASSINSTALL_HEADER
        {
            public Int32 cbSize;
            public UInt32 InstallFunction;
        }

        [DllImport("setupapi.dll", SetLastError = true)]
        static extern bool SetupDiSetClassInstallParams(
            IntPtr DeviceInfoSet, ref SP_DEVINFO_DATA DeviceInfoData,
            ref SP_CLASSINSTALL_HEADER ClassInstallParams, Int32 ClassInstallParamsSize);

        [DllImport("setupapi.dll", SetLastError = true)]
        static extern bool SetupDiCallClassInstaller(
            UInt32 InstallFunction, IntPtr DeviceInfoSet, ref SP_DEVINFO_DATA DeviceInfoData);

        [StructLayout(LayoutKind.Sequential)]
        struct SP_PROPCHANGE_PARAMS
        {
            public SP_CLASSINSTALL_HEADER ClassInstallHeader;
            public Int32 StateChange;
            public Int32 Scope;
            public Int32 HwProfile;
        }

        [StructLayout(LayoutKind.Sequential)]
        struct SP_DEVINSTALL_PARAMS
        {
            public Int32 cbSize;
            public Int32 Flags;
            public Int32 FlagsEx;
            public IntPtr hwndParent;
            public IntPtr InstallMsgHandler;
            public IntPtr InstallMsgHandlerContext;
            public IntPtr FileQueue;
            public IntPtr ClassInstallReserved;
            public Int32 Reserved;
            //TCHAR  DriverPath[MAX_PATH];
            public byte[] DriverPath;// = new byte[LINE_LEN];
        }

        [DllImport("setupapi.dll", SetLastError = true)]
        static extern bool SetupDiGetDeviceInstallParams(
            IntPtr DeviceInfoSet, ref SP_DEVINFO_DATA DeviceInfoData,
            ref SP_DEVINSTALL_PARAMS DeviceInstallParams);

        [StructLayout(LayoutKind.Sequential)]
        struct SP_REMOVEDEVICE_PARAMS
        {
            public SP_CLASSINSTALL_HEADER ClassInstallHeader;
            public Int32 Scope;
            public Int32 HwProfile;
        }

        [DllImport("cfgmgr32.dll")]
        static extern UInt32 CM_Get_Device_ID_Ex(
            Int32 dnDevInst, byte[] Buffer, UInt32 BufferLen,
            UInt32 ulFlags, IntPtr hMachine);

        [DllImport("cfgmgr32.dll")]
        static extern UInt32 CM_Get_DevNode_Status_Ex(
            ref UInt32 pulStatus, ref UInt32 pulProblemNumber,
            Int32 dnDevInst, UInt32 ulFlags, IntPtr hMachine);

        [StructLayout(LayoutKind.Sequential)]
        public struct SP_DEVINFOSTATUS_DATA
        {
            public string DeviceName;
            public UInt32 pulStatus;
            public UInt32 pulProblemNumber;
        }

        public const int DIGCF_PRESENT = (0x00000002);          // Return only devices that are present currently.
        public const int DIGCF_ALLCLASSES = (0x00000004);       // Return a list of installed devices for all classes.
        public const int DIGCF_DEVICEINTERFACE = (0x00000010);  // Return devices that expose interfaces of the interface class that are specified by ClassGuid.
        public const int DIGCF_PROFILE = (0x00000008);          // Return only devices that are a part of the current hardware profile.

        public const int DICS_ENABLE = 1;
        public const int DICS_FLAG_GLOBAL = 1;
        public const int DICS_DISABLE = 2;
        public const int DICS_FLAG_CONFIGSPECIFIC = 2;
        public const int DIF_REMOVE = 5;
        public const int DIF_PROPERTYCHANGE = 18;

        public const int DN_STARTED = (0x00000008);
        public const int DN_HAS_PROBLEM = (0x00000400);
        public const int DN_PRIVATE_PROBLEM = (0x00008000);

        public const int CM_PROB_DISABLED = (0x00000016);

        private const int DI_REMOVEDEVICE_GLOBAL = (0x00000001);
        private const int DI_NEEDRESTART = (0x00000080);
        private const int DI_NEEDREBOOT = (0x00000100);

        private const int SPDRP_FRIENDLYNAME = (0x0000000C);
        private const int SPDRP_DEVICEDESC = (0x00000000);

        private const int CR_SUCCESS = (0x00000000);
        private const int CR_NO_SUCH_VALUE = (0x00000025);
        private const int CR_INVALID_DATA = (0x0000001F);

        private const int LINE_LEN = 256;

        public static readonly IntPtr INVALID_HANDLE_VALUE = new IntPtr(-1);

        private static string GetDeviceStringProperty(IntPtr DeviceInfoSet, ref SP_DEVINFO_DATA DeviceInfoData, Int32 Prop)
        {
            Int32 dataType = (Int32)Microsoft.Win32.RegistryValueKind.String;
            Int32 ReqSize = 0;
            byte[] PropertyBuffer = new byte[1024];

            if (!SetupDiGetDeviceRegistryProperty(DeviceInfoSet, ref DeviceInfoData, Prop, ref dataType, PropertyBuffer, 1024, ref ReqSize))
            {
                return null;
            }

            UnicodeEncoding encoding = new UnicodeEncoding();
            //ASCIIEncoding encoding = new ASCIIEncoding();
            return encoding.GetString(PropertyBuffer).Remove((ReqSize / 2) - 1);
        }

        public static bool GetClassIcon(ref Guid ClassGuid, ref IntPtr LargeIcon, ref int MiniIconIndex)
        {
            return SetupDiLoadClassIcon(ref ClassGuid, ref LargeIcon, ref MiniIconIndex);
        }

        public static bool GetClassDescriptionEx(ref Guid ClassGuid, ref string ClassDescription, string MachineName)
        {
            byte[] ClassesDesc = new byte[LINE_LEN];
            int RequiredSize = 0;

            if (!SetupDiGetClassDescriptionEx(ref ClassGuid, ClassesDesc, LINE_LEN, ref RequiredSize, MachineName, IntPtr.Zero))
            {
                return false;
            }

            if (RequiredSize > LINE_LEN)
                return false;

            UnicodeEncoding encoding = new UnicodeEncoding();
            //ASCIIEncoding encoding = new ASCIIEncoding();
            ClassDescription = encoding.GetString(ClassesDesc).Remove(RequiredSize - 1);

            return true;
        }

        public static bool EnumerateClasses(string MachineName, Int32 Flags,
            ref Guid[] GuidNameList, ref string[] ClassesNameList, Int32 ListSize, ref Int32 RequiredSize)
        {
            Int32 ClassesCount = 0;
            Guid ClassGuid = Guid.Empty;
            for (uint idx = 0; idx < ListSize; idx++)
            {
                uint result = CM_Enumerate_Classes(idx, ref ClassGuid, 0);
                if (result != CR_SUCCESS)
                {
                    if (result == CR_INVALID_DATA)
                        continue;
                    else if (result == CR_NO_SUCH_VALUE)
                        break;
                }

                GuidNameList[ClassesCount] = ClassGuid;
                ClassesCount++;
            }
            RequiredSize = ClassesCount;

            byte[] ClassesName = new byte[LINE_LEN];
            Int32 reqSize = 0;
            ClassesCount = 0;
            for (int index = 0; index < RequiredSize; index++)
            {
                if (!SetupDiClassNameFromGuidEx(ref GuidNameList[index], ClassesName, LINE_LEN, ref reqSize, MachineName, IntPtr.Zero))
                {
                    continue;
                }

                UnicodeEncoding encoding = new UnicodeEncoding();
                //ASCIIEncoding encoding = new ASCIIEncoding();
                ClassesNameList[ClassesCount] = encoding.GetString(ClassesName).Remove(reqSize - 1);
                ClassesCount++;
            }
            RequiredSize = ClassesCount;

            return true;
        }

        public static bool EnumerateDevices(string MachineName, string ClassStr, Int32 Flags,
            ref SP_DEVINFOSTATUS_DATA[] DeviceInfoStatusList, Int32 DeviceInfoStatusListSize, ref Int32 RequiredSize)
        {
            Guid ClassGuid = Guid.Empty;
            Int32 numClass = 0;

            IntPtr hdevinfo = IntPtr.Zero;

            if (null != ClassStr && 0 != ClassStr.Length)
            {
                if (!SetupDiClassGuidsFromNameEx(ClassStr, ref ClassGuid, 1, ref numClass, MachineName, IntPtr.Zero))
                    return false;
            }

            hdevinfo = SetupDiGetClassDevsEx(ref ClassGuid, null, IntPtr.Zero,
                Flags, IntPtr.Zero, MachineName, IntPtr.Zero);
            if (hdevinfo == INVALID_HANDLE_VALUE)
            {
                return false;
            }

            SP_DEVINFO_DATA devInfo = new SP_DEVINFO_DATA();
            devInfo.cbSize = Marshal.SizeOf(devInfo);
            int devIndex = 0;
            for (devIndex = 0; SetupDiEnumDeviceInfo(hdevinfo, devIndex, ref devInfo) && devIndex < DeviceInfoStatusListSize; devIndex++)
            {
                string desc;
                desc = GetDeviceStringProperty(hdevinfo, ref devInfo, SPDRP_FRIENDLYNAME);
                if (null == desc)
                {
                    desc = GetDeviceStringProperty(hdevinfo, ref devInfo, SPDRP_DEVICEDESC);
                }

                UInt32 status = 0;
                UInt32 problemNumber = 0;
                if (CM_Get_DevNode_Status_Ex(ref status, ref problemNumber, devInfo.DevInst, 0, IntPtr.Zero) != CR_SUCCESS)
                {
                    return false;
                }

                DeviceInfoStatusList[devIndex].DeviceName = desc;
                DeviceInfoStatusList[devIndex].pulStatus = status;
                DeviceInfoStatusList[devIndex].pulProblemNumber = problemNumber;
            }

            RequiredSize = devIndex;

            if (hdevinfo != INVALID_HANDLE_VALUE)
            {
                SetupDiDestroyDeviceInfoList(hdevinfo);
            }

            return true;
        }

        public static bool DeviceControl(Guid ClassGuid, Int32 DeviceIndex, Int32 Action)
        {
            IntPtr hdevinfo = IntPtr.Zero;
            hdevinfo = SetupDiGetClassDevsEx(ref ClassGuid, null, IntPtr.Zero,
                DIGCF_PRESENT, IntPtr.Zero, null, IntPtr.Zero);
            if (hdevinfo == INVALID_HANDLE_VALUE)
            {
                return false;
            }

            SP_DEVINFO_DATA DevInfo = new SP_DEVINFO_DATA();
            DevInfo.cbSize = Marshal.SizeOf(DevInfo);
            if (!SetupDiEnumDeviceInfo(hdevinfo, DeviceIndex, ref DevInfo))
            {
                return false;
            }

            SP_PROPCHANGE_PARAMS pcp = new SP_PROPCHANGE_PARAMS();

            switch (Action)
            {
                case DICS_ENABLE:
                    //
                    // enable both on global and config-specific profile
                    // do global first and see if that succeeded in enabling the device
                    // (global enable doesn't mark reboot required if device is still
                    // disabled on current config whereas vice-versa isn't true)
                    //
                    pcp.ClassInstallHeader.cbSize = Marshal.SizeOf(pcp.ClassInstallHeader);
                    pcp.ClassInstallHeader.InstallFunction = DIF_PROPERTYCHANGE;
                    pcp.StateChange = Action;
                    pcp.Scope = DICS_FLAG_GLOBAL;
                    pcp.HwProfile = 0;
                    //
                    // don't worry if this fails, we'll get an error when we try config-
                    // specific.
                    if (SetupDiSetClassInstallParams(hdevinfo, ref DevInfo, ref pcp.ClassInstallHeader, Marshal.SizeOf(pcp)))
                    {
                        SetupDiCallClassInstaller(DIF_PROPERTYCHANGE, hdevinfo, ref DevInfo);
                    }
                    //
                    // now enable on config-specific
                    //
                    pcp.ClassInstallHeader.cbSize = Marshal.SizeOf(pcp.ClassInstallHeader);
                    pcp.ClassInstallHeader.InstallFunction = DIF_PROPERTYCHANGE;
                    pcp.StateChange = Action;
                    pcp.Scope = DICS_FLAG_CONFIGSPECIFIC;
                    pcp.HwProfile = 0;
                    break;

                default:
                    //
                    // operate on config-specific profile
                    //
                    pcp.ClassInstallHeader.cbSize = Marshal.SizeOf(pcp.ClassInstallHeader);
                    pcp.ClassInstallHeader.InstallFunction = DIF_PROPERTYCHANGE;
                    pcp.StateChange = Action;
                    pcp.Scope = DICS_FLAG_CONFIGSPECIFIC;
                    pcp.HwProfile = 0;
                    break;
            }

            SP_DEVINSTALL_PARAMS devParams = new SP_DEVINSTALL_PARAMS();
            if (!SetupDiSetClassInstallParams(hdevinfo, ref DevInfo, ref pcp.ClassInstallHeader, Marshal.SizeOf(pcp)) ||
                !SetupDiCallClassInstaller(DIF_PROPERTYCHANGE, hdevinfo, ref DevInfo))
            {
                //
                // failed to invoke DIF_PROPERTYCHANGE
                //
            }
            else
            {
                //
                // see if device needs reboot
                //
                devParams.cbSize = Marshal.SizeOf(devParams);
                if (SetupDiGetDeviceInstallParams(hdevinfo, ref DevInfo, ref devParams) && 0 != (devParams.Flags & (DI_NEEDRESTART | DI_NEEDREBOOT)))
                {
                    //
                    // reboot required
                    //
                }
                else
                {
                    //
                    // appears to have succeeded
                    //
                }
            }

            return true;
        }

        public static bool DeviceRemove(Guid ClassGuid, Int32 DeviceIndex)
        {
            IntPtr hdevinfo = IntPtr.Zero;
            hdevinfo = SetupDiGetClassDevsEx(ref ClassGuid, null, IntPtr.Zero,
                DIGCF_PRESENT, IntPtr.Zero, null, IntPtr.Zero);
            if (hdevinfo == INVALID_HANDLE_VALUE)
            {
                return false;
            }

            SP_DEVINFO_DATA DevInfo = new SP_DEVINFO_DATA();
            DevInfo.cbSize = Marshal.SizeOf(DevInfo);
            if (!SetupDiEnumDeviceInfo(hdevinfo, DeviceIndex, ref DevInfo))
            {
                return false;
            }

            SP_REMOVEDEVICE_PARAMS rmdParams = new SP_REMOVEDEVICE_PARAMS();
            SP_DEVINSTALL_PARAMS devParams = new SP_DEVINSTALL_PARAMS();
            //
            // need hardware ID before trying to remove, as we wont have it after
            //
            byte[] devID = new byte[LINE_LEN];
            SP_DEVINFO_LIST_DETAIL_DATA devInfoListDetail = new SP_DEVINFO_LIST_DETAIL_DATA();

            devInfoListDetail.cbSize = Marshal.SizeOf(devInfoListDetail);
            if (/*(!SetupDiGetDeviceInfoListDetail(hdevinfo, ref devInfoListDetail)) ||*/
                (CM_Get_Device_ID_Ex(DevInfo.DevInst, devID, LINE_LEN, 0, devInfoListDetail.RemoteMachineHandle) != CR_SUCCESS))
            {
                //
                // skip this
                //
                return true;
            }

            rmdParams.ClassInstallHeader.cbSize = Marshal.SizeOf(rmdParams.ClassInstallHeader);
            rmdParams.ClassInstallHeader.InstallFunction = DIF_REMOVE;
            rmdParams.Scope = DI_REMOVEDEVICE_GLOBAL;
            rmdParams.HwProfile = 0;
            if (!SetupDiSetClassInstallParams(hdevinfo, ref DevInfo, ref rmdParams.ClassInstallHeader, Marshal.SizeOf(rmdParams)) ||
                !SetupDiCallClassInstaller(DIF_REMOVE, hdevinfo, ref DevInfo))
            {
                //
                // failed to invoke DIF_REMOVE
                //
            }
            else
            {
                //
                // see if device needs reboot
                //
                devParams.cbSize = Marshal.SizeOf(devParams);
                if (SetupDiGetDeviceInstallParams(hdevinfo, ref DevInfo, ref devParams) && 0 != (devParams.Flags & (DI_NEEDRESTART | DI_NEEDREBOOT)))
                {
                    //
                    // reboot required
                    //
                }
                else
                {
                    //
                    // appears to have succeeded
                    //
                }
            }

            return true;
        }

        public static string GetSOLPortName()
        {
            SP_DEVINFOSTATUS_DATA[] DeviceInfoStatusList = new SP_DEVINFOSTATUS_DATA[16];

            int DevReqSize = 0;
            if (!EnumerateDevices(null, "Ports", DIGCF_PRESENT, ref DeviceInfoStatusList, 16, ref DevReqSize))
            {
                return null;
            }

            int idx = 0;
            for (idx = 0; idx < DevReqSize; idx++)
            {
                if (DeviceInfoStatusList[idx].DeviceName.Contains("SOL"))
                {
                    string[] str = DeviceInfoStatusList[idx].DeviceName.Split('(');
                    string[] name = str[str.Length - 1].Split(')');

                    return name[0];
                }
                else if (DeviceInfoStatusList[idx].DeviceName.Contains("Intel(R) Active Management Technology")) // This seems to work in all GEO's, not reported problems.
                { 
                    string[] str = DeviceInfoStatusList[idx].DeviceName.Split('(');
                    string[] name = str[str.Length - 1].Split(')');

                    return name[0];
                }
                else if (DeviceInfoStatusList[idx].DeviceName.Contains("Intel(R) Active Management Technology - SOL")) // This seems to work in all GEO's, not reported problems.
                {
                    string[] str = DeviceInfoStatusList[idx].DeviceName.Split('(');
                    string[] name = str[str.Length - 1].Split(')');

                    return name[0];
                }
            }
            
            return null;
        }
    }
}
