// =============================================================================
// Copyright 2008-2011. Intel Corporation All Rights Reserved.
//
// The source code contained or described herein and all documents related to 
// the source code ("Material") are owned by Intel Corporation or its suppliers 
// or licensors. Title to the Material remains with Intel Corporation or its 
// suppliers and licensors. The Material may contain trade secrets and 
// proprietary and confidential information of Intel Corporation and its 
// suppliers and licensors, and is protected by worldwide copyright and trade 
// secret laws and treaty provisions. No part of the Material may be used, 
// copied, reproduced, modified, published, uploaded, posted, transmitted, 
// distributed, or disclosed in any way without Intels prior express written 
// permission. 
//
// No license under any patent, copyright, trade secret or other intellectual 
// property right is granted to or conferred upon you by disclosure or delivery 
// of the Materials, either expressly, by implication, inducement, estoppel or 
// otherwise. Any license under such intellectual property rights must be 
// express and approved by Intel in writing.
// =============================================================================
using System;
using System.IO;
using System.Data;
using System.Text;
using System.Drawing;
using System.Windows.Forms;
using System.ComponentModel;
using System.Collections.Generic;

namespace ManageabilityTerminalTool
{
    public partial class MainForm : Form
    {
        public MainForm(string[] args)
        {
            InitializeComponent();
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            this.Text = FilterStrEx(this.Text);
            string exename = new FileInfo(Application.ExecutablePath).Name;
            if (exename.ToUpper().EndsWith(".EXE", true, System.Threading.Thread.CurrentThread.CurrentUICulture)) exename = exename.Substring(0, exename.Length - 4);
            label2.Text = string.Format(label2.Text, exename);
            label4.Text = string.Format(label4.Text, exename);
        }

        public static string FilterStrEx(string s)
        {
            if (s == null) return null;
            if (s.IndexOf('\0') >= 0) s = s.Substring(0, s.IndexOf('\0'));
            s = s.Replace("(R)", "" + (char)0x00AE).Replace("(C)", "" + (char)0x00A9).Trim();
            return s;
        }

        private void okButton_Click(object sender, EventArgs e)
        {
            Close();
        }
    }
}
