// AMTLib.cpp : Defines the initialization routines for the DLL.
//

#include <Windows.h>
#include <stdio.h>

#include "StorageWrapper.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


/* Main DLL entry
*  
*  \param HANDLE hModule
*  \param DWORD  ul_reason_for_call
*  \param LPVOID lpReserved
*  \return BOOL
*/
BOOL APIENTRY DllMain( HANDLE hModule, 
                      DWORD  ul_reason_for_call, 
                      LPVOID lpReserved
                      )
{
    switch (ul_reason_for_call)
    {
    case DLL_PROCESS_ATTACH:
    case DLL_THREAD_ATTACH:
    case DLL_THREAD_DETACH:
    case DLL_PROCESS_DETACH:
        break;
    }
    return TRUE;
}

STORAGE_API PT_STATUS __stdcall Storage_Initialize(
    INOUT UINT32 *LibMajorVersion, 
    INOUT UINT32 *LibMinorVersion, 
    OUT UINT32 *LibBuildNumber)
{
    return ISVS_Initialize(LibMajorVersion, LibMinorVersion, LibBuildNumber);
}

STORAGE_API PT_STATUS __stdcall Storage_Uninitialize()
{
    return ISVS_Uninitialize();
}
STORAGE_API PT_STATUS __stdcall Storage_InitializeCOMinThread()
{
    return ISVS_InitializeCOMinThread();
}

STORAGE_API PT_STATUS __stdcall Storage_UninitializeCOMinThread()
{
    return ISVS_UninitializeCOMinThread();
}

STORAGE_API PT_STATUS __stdcall Storage_RegisterApplicationEx(
    OUT SESSION_HANDLE             *SessionHandle,
    IN  wchar_t                    *Username    OPTIONAL,
    IN  wchar_t                    *Password    OPTIONAL,
    IN  CHAR                       *TargetUrl   ,
    IN  PT_UUID                    MachineUUID  OPTIONAL,
    IN  PTSDK_UNICODE_STRING       *VendorName,
    IN  PTSDK_UNICODE_STRING       *AppName,
    IN  PTSDK_UNICODE_STRING       *EnterpriseName,
    IN  SESSION_AUTHENTICATION_INFO          *AuthInfo   OPTIONAL
    )
{
    return ISVS_RegisterApplicationEx(SessionHandle, Username, Password, TargetUrl, MachineUUID, 
        VendorName, AppName, EnterpriseName, AuthInfo);
}


STORAGE_API PT_STATUS __stdcall Storage_GetRegisteredApplications(
    IN    SESSION_HANDLE           SessionHandle,
    IN    UINT32                   StartIndex,
    OUT   UINT32                   *TotalRegisteredAppCount,
    INOUT UINT32                   *AppHandleCount,
    OUT   ISVS_APPLICATION_HANDLE  AppHandles[]        // [<AppHandleCount>]
)
{
    return ISVS_GetRegisteredApplications(SessionHandle, StartIndex, TotalRegisteredAppCount,
        AppHandleCount, AppHandles);
}



STORAGE_API PT_STATUS __stdcall Storage_GetCurrentApplicationHandle (
    IN  SESSION_HANDLE             SessionHandle,
    OUT	ISVS_APPLICATION_HANDLE    *AppHandle
    )
{
    return ISVS_GetCurrentApplicationHandle(SessionHandle, AppHandle);
}

STORAGE_API PT_STATUS __stdcall Storage_GetApplicationAttributes(
    IN    SESSION_HANDLE                    SessionHandle,
    IN    ISVS_APPLICATION_HANDLE           ApplicationBeingRequested,
    INOUT PTSDK_APPLICATION_ATTRIBUTES      *ApplicationAttributes
    )
{
    return ISVS_GetApplicationAttributes(SessionHandle, ApplicationBeingRequested,
        ApplicationAttributes);
}

STORAGE_API PT_STATUS __stdcall Storage_UnregisterApplication(
    IN SESSION_HANDLE       SessionHandle
    )
{
    return ISVS_UnregisterApplication(SessionHandle);
}

STORAGE_API PT_STATUS __stdcall Storage_RemoveApplication(
    SESSION_HANDLE          SessionHandle
    )
{
    return ISVS_RemoveApplication(SessionHandle);
}

STORAGE_API PT_STATUS __stdcall Storage_GetBytesAvailable(
    IN  SESSION_HANDLE      SessionHandle,
    OUT UINT32              *BytesAvailable
    )
{
    return ISVS_GetBytesAvailable(SessionHandle, BytesAvailable);
}

STORAGE_API PT_STATUS __stdcall Storage_AllocateBlock(
    IN  SESSION_HANDLE          SessionHandle,
    IN  UINT32                  BytesRequested,
    IN  PT_BOOLEAN              BlockHidden,
    IN  PTSDK_UNICODE_STRING    *BlockName,
    OUT ISVS_BLOCK_HANDLE       *BlockHandle
    )
{
    return ISVS_AllocateBlock(SessionHandle, BytesRequested, BlockHidden, BlockName,
        BlockHandle);
}

STORAGE_API PT_STATUS __stdcall Storage_GetAllocatedBlocks(
    IN    SESSION_HANDLE            SessionHandle,
    IN    ISVS_APPLICATION_HANDLE   BlockOwnerApplication,
    IN    UINT32                    StartIndex,
    OUT   UINT32                    *TotalAllocatedBlockCount,
    INOUT UINT32                    *BlockHandleCount,
    OUT   ISVS_BLOCK_HANDLE         BlockHandles[]      // [<BlockHandleCount>]
)
{
    return ISVS_GetAllocatedBlocks(SessionHandle, BlockOwnerApplication, StartIndex,
        TotalAllocatedBlockCount, BlockHandleCount,
        BlockHandles);
}

STORAGE_API PT_STATUS __stdcall Storage_GetBlockAttributes(
    IN    SESSION_HANDLE            SessionHandle,
    IN    ISVS_BLOCK_HANDLE         BlockHandle,
    INOUT PTSDK_BLOCK_ATTRIBUTES    **BlockAttributes
    )
{
    return ISVS_GetBlockAttributes(SessionHandle, BlockHandle, *BlockAttributes);
}


STORAGE_API PT_STATUS __stdcall Storage_DeallocateBlock(
    IN  SESSION_HANDLE          SessionHandle,
    IN  ISVS_BLOCK_HANDLE       BlockHandle
    )
{
    return ISVS_DeallocateBlock(SessionHandle, BlockHandle);
}

STORAGE_API PT_STATUS __stdcall Storage_WriteBlock(
    IN  SESSION_HANDLE          SessionHandle,
    IN  ISVS_BLOCK_HANDLE       BlockHandle,
    IN  UINT32                  ByteOffset,
    IN  UINT32                  ByteCount,
    OUT UINT32                  *BytesWritten,
    IN  UINT8                   Data[]
)
{
    return ISVS_WriteBlock(SessionHandle, BlockHandle, ByteOffset, ByteCount,
        BytesWritten, Data);
}

STORAGE_API PT_STATUS __stdcall Storage_ReadBlock(
    IN    SESSION_HANDLE        SessionHandle,
    IN    ISVS_BLOCK_HANDLE     BlockHandle,
    IN    UINT32                ByteOffset,
    IN    UINT32                ByteCount,
    OUT   UINT32                *BytesRead,
    OUT   UINT8                 Data[]
)
{
    return ISVS_ReadBlock(SessionHandle, BlockHandle, ByteOffset, ByteCount,
        BytesRead, Data);

}

STORAGE_API PT_STATUS __stdcall Storage_LockBlock(
    IN SESSION_HANDLE           SessionHandle,
    IN ISVS_BLOCK_HANDLE        BlockHandle
    )
{
    return ISVS_LockBlock( SessionHandle,  BlockHandle);
}

STORAGE_API PT_STATUS __stdcall Storage_UnlockBlock(
    IN SESSION_HANDLE           SessionHandle,
    IN ISVS_BLOCK_HANDLE        BlockHandle
    )
{
    return ISVS_UnlockBlock(SessionHandle, BlockHandle);
}

STORAGE_API PT_STATUS __stdcall Storage_SetBlockName(
    IN SESSION_HANDLE           SessionHandle,
    IN ISVS_BLOCK_HANDLE        BlockHandle,
    IN PTSDK_UNICODE_STRING     *BlockName
    )
{
    return ISVS_SetBlockName(SessionHandle, BlockHandle, BlockName);
}

STORAGE_API PT_STATUS __stdcall Storage_SetBlockVisibility(
    IN SESSION_HANDLE           SessionHandle,
    IN ISVS_BLOCK_HANDLE        BlockHandle,
    IN PT_BOOLEAN               BlockHidden
    )
{
    return ISVS_SetBlockVisibility(SessionHandle, BlockHandle, BlockHidden);
}

STORAGE_API PT_STATUS __stdcall Storage_AddPermissionsGroup(
    IN  SESSION_HANDLE          SessionHandle,
    IN  ISVS_BLOCK_HANDLE       BlockHandle,
    IN  ISVS_GROUP_PERMISSIONS  GroupPermissions,
    IN  PTSDK_UNICODE_STRING    *GroupName,
    OUT ISVS_GROUP_HANDLE       *GroupHandle
    )
{
    return ISVS_AddPermissionsGroup(SessionHandle, BlockHandle, GroupPermissions,
        GroupName, GroupHandle);
}

STORAGE_API PT_STATUS __stdcall Storage_GetPermissionsGroups(
    IN    SESSION_HANDLE        SessionHandle,
    IN    ISVS_BLOCK_HANDLE     BlockHandle,
    IN    UINT32                StartIndex,
    OUT   UINT32                *TotalGroupCount,
    INOUT UINT32                *GroupHandleCount,
    OUT   ISVS_GROUP_HANDLE     **GroupHandles  // [<HandleCount>]
    )
{
    return ISVS_GetPermissionsGroups(SessionHandle, BlockHandle, StartIndex, TotalGroupCount,
        GroupHandleCount, *GroupHandles);
}

STORAGE_API PT_STATUS __stdcall Storage_GetPermissionsGroupAttributes(
    IN    SESSION_HANDLE                        SessionHandle,
    IN    ISVS_BLOCK_HANDLE                     BlockHandle,
    IN    ISVS_GROUP_HANDLE                     GroupHandle,
    INOUT PTSDK_PERMISSIONS_GROUP_ATTRIBUTES    **GroupAttributes
    )
{
    return ISVS_GetPermissionsGroupAttributes(SessionHandle, BlockHandle, GroupHandle,
        *GroupAttributes);
}

STORAGE_API PT_STATUS __stdcall Storage_RemovePermissionsGroup(
    IN SESSION_HANDLE          SessionHandle,
    IN ISVS_BLOCK_HANDLE       BlockHandle,
    IN ISVS_GROUP_HANDLE       GroupHandle
    )
{
    return ISVS_RemovePermissionsGroup(SessionHandle, BlockHandle, GroupHandle);
}

STORAGE_API PT_STATUS __stdcall Storage_SetPermissionsGroupName(
    IN SESSION_HANDLE           SessionHandle,
    IN ISVS_BLOCK_HANDLE        BlockHandle,
    IN ISVS_GROUP_HANDLE        GroupHandle,
    IN PTSDK_UNICODE_STRING     *GroupName
    )
{
    return ISVS_SetPermissionsGroupName(SessionHandle, BlockHandle, GroupHandle, GroupName);
}

STORAGE_API PT_STATUS __stdcall Storage_SetPermissionsGroupPermissions(
    IN SESSION_HANDLE           SessionHandle,
    IN ISVS_BLOCK_HANDLE        BlockHandle,
    IN ISVS_GROUP_HANDLE        GroupHandle,
    IN ISVS_GROUP_PERMISSIONS   Permissions
    )
{
    return ISVS_SetPermissionsGroupPermissions(SessionHandle, BlockHandle, GroupHandle, Permissions);
}

STORAGE_API PT_STATUS __stdcall Storage_AddPermissionsGroupMembers(
    IN SESSION_HANDLE           SessionHandle,
    IN ISVS_BLOCK_HANDLE        BlockHandle,
    IN ISVS_GROUP_HANDLE        GroupHandle,
    IN UINT32                   MemberHandleCount,
    IN ISVS_APPLICATION_HANDLE  MemberHandles[]      // [<MemberHandleCount>]
)
{
    return ISVS_AddPermissionsGroupMembers(SessionHandle, BlockHandle, GroupHandle, 
        MemberHandleCount, MemberHandles);
}

STORAGE_API PT_STATUS __stdcall Storage_GetPermissionsGroupMembers(
    IN    SESSION_HANDLE            SessionHandle,
    IN    ISVS_BLOCK_HANDLE         BlockHandle,
    IN    ISVS_GROUP_HANDLE         GroupHandle,
    IN    UINT32                    StartIndex,
    OUT   UINT32                    *TotalMemberCount,
    INOUT UINT32                    *MemberHandleCount,
    OUT   ISVS_APPLICATION_HANDLE   MemberHandles[]      // [<MemberHandleCount>]
)
{
    return ISVS_GetPermissionsGroupMembers(SessionHandle, BlockHandle, GroupHandle,
        StartIndex, TotalMemberCount, MemberHandleCount,
        MemberHandles);
}

STORAGE_API PT_STATUS __stdcall Storage_RemovePermissionsGroupMembers(
    IN SESSION_HANDLE           SessionHandle,
    IN ISVS_BLOCK_HANDLE        BlockHandle,
    IN ISVS_GROUP_HANDLE        GroupHandle,
    IN UINT32                   MemberHandleCount,
    IN ISVS_APPLICATION_HANDLE  MemberHandles[]      // [<MemberHandleCount>]
)
{
    return ISVS_RemovePermissionsGroupMembers(SessionHandle, BlockHandle, GroupHandle,
        MemberHandleCount, MemberHandles);
}

STORAGE_API PT_STATUS __stdcall Storage_GetTimeoutValues(
    IN  SESSION_HANDLE          SessionHandle,
    OUT UINT32                  *RegistrationTimeout,
    OUT UINT32                  *LockTimeout
    )
{
    return ISVS_GetTimeoutValues( SessionHandle, RegistrationTimeout, LockTimeout);
}

STORAGE_API PT_STATUS __stdcall Storage_GetHostUUID(
    OUT PT_UUID         Uuid
    )
{
    return ISVS_GetHostUUID(Uuid);
}

STORAGE_API PT_STATUS __stdcall Storage_GetAPIVersion(
    IN  wchar_t             *Username   OPTIONAL,
    IN  wchar_t             *Password   OPTIONAL,
    IN  CHAR                *TargetUrl,
    OUT ISVS_VERSION        *Version
    )
{
    return ISVS_GetAPIVersion(Username, Password, TargetUrl, Version);
}

STORAGE_API PT_STATUS __stdcall Storage_GetAPIVersionEx(
    OUT ISVS_VERSION    *Version,
    IN  wchar_t             *Username   OPTIONAL,
    IN  wchar_t             *Password   OPTIONAL,
    IN  CHAR                *TargetUrl,
    IN  SESSION_AUTHENTICATION_INFO   *AuthInfo   OPTIONAL
    )
{
    return ISVS_GetAPIVersionEx(Version, Username, Password, TargetUrl, AuthInfo);
}

STORAGE_API PT_STATUS __stdcall Storage_GetBlockWriteEraseLimit(
    IN SESSION_HANDLE       SessionHandle,
    IN ISVS_BLOCK_HANDLE    BlockHandle,
    OUT UINT32              *WriteEraseLimit
    )
{
    return ISVS_GetBlockWriteEraseLimit( SessionHandle, BlockHandle, WriteEraseLimit);
}

STORAGE_API VOID __stdcall Storage_GetLastNetworkError(
    IN  SESSION_HANDLE  SessionHandle  OPTIONAL,
    OUT VOID            *NetworkError
    )
{
    ISVS_GetLastNetworkError(SessionHandle, NetworkError);
}

